C      PROGRAM PFSR
C PROGRAM FOR RIETVELD ANALYSIS OF X-RAY AND NEUTRON (NUCLEAR SCATTERING
C ONLY) POWDER DIFFRACTION PATTERNS
C   VERSION DBW3.2S-8711
C   SCHOOL OF PHYSICS (R. A. YOUNG)
C   GEORGIA INSTITUTE OF TECHNOLOGY, ATLANTA, GA. 30332  USA
C   PRECURSOR PROGRAM, DBW3.2, WRITTEN BY D. B. WILES
C   DBW3.2S CREATED BY A. SAKTHIVEL BY MODIFICATION OF DBW3.2
C   DURING JAN 86 - NOV 87
C   GET USER'S GUIDE FROM PROF. R. A. YOUNG AT ABOVE ADDRESS
C
C   MODIFIED BY J.RODRIGUEZ (APRIL-1989) TO INTRODUCE THE
C   FEATURES TO RUN WITH TIME-RESOLVED DATA AND TO DO 
C   MAXIMUM LIKELIHOOD REFINEMENTS
C
C  MODIFIED BY A. LE BAIL: 
C     SUBSTRACT IMMEDIATLY THE
C     BACKGROUND WHEN NBCKGD > 2 , LINE 2.
C     SO, Rp and Rwp are corresponding to " background substracted "
C                            ......................................
C     FOR X-RAY O2- WAS ADDED (DB4.FOR, THE LAST)
C
C     IN SUBROUTINE CALCUL: THE STRUCTURE FACTOR
C        WAS THAT FOR A SINGLE CRYSTAL FOR hkl
C        (THE ERROR SEEMS TO COME FROM ILL......)
C        THIS WAS NOT A PROBLEM IF DELTA f" WAS ZERO...
C                     OR IF THE STRUCTURE WAS CENTRIC
C
C        NOW THE STUCTURE FACTOR IS CORRECT:
C               INTENSITY IS THE SUM OF hkl
C               AND -h-k-l CONTRIBUTIONS.....  
C
C234567
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      REAL LAMDA
      INTEGER PTR
      COMMON/DC/SAVE(8,6),NSAVE
      COMMON/REFLS/IREFS(IRS),REFS(IRS,3),FF(IRS),PHASEN(IRS),IC(8)
     } ,HALFL(IRS),HALFG(IRS),GAM(IRS)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1
      CHARACTER TITLE*70,PHSNM(8)*70
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(10,16),POSI(30),SCAT(30),DFP(16),DFPP(16)
      CHARACTER*4 NAM(16)
      COMMON/COEFC/NAM
C&    COMMON/CONSTR/CONA(2,16,8),ICON(2,16,8),JCON(2,16,8),LCONI(2,16,8)
C&   *,LCONJ(2,16,8),DF(2,16),LN(2,16)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ)
     *,IWW(IDSZ),NPTS
      COMMON/RTMTX/IVEC(8,192),MLT(8),ICET(8)
      CALL INPTR
C     CALL ASSIGN
      CALL ITER
      CALL EXPUT
      STOP
      END
      SUBROUTINE COEF(J,K)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/COEFF/AC(10,16),POSI(30),SCAT(30),DFP(16),DFPP(16)
      CHARACTER*4 NAM(16)
      COMMON/COEFC/NAM
      COMMON/CNV/N,SINLAM(30),F(30)
      DIMENSION AB(10)
      EXTERNAL CV1,CV2
      DO 10 I=1,K
      SINLAM(I)=POSI(I)*POSI(I)
   10 F(I)=SCAT(I)
      N=K
      NN=MIN0(N,9)
      DO 15 I=1,NN
   15 AB(I)=I
      NN1=NN+1
      DO 16 I=NN1,10
   16 AB(I)=0
      CALL STEEP(AB,3,10,CV2,CV1)
      IF(AB(3).EQ.0.)AB(3)=-1E-6
      DO 20 I=1,9
   20 AC(I,J)=AB(I)
      RETURN
      END
      SUBROUTINE CV1(AB,V)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/CNV/N,SINLAM(30),F(30)
      DIMENSION AB(10),V(10)
      MAXX=MIN0(9,N)
      DO 30 K=1,MAXX,2
      V(K)=0
      DO 20 I=1,N
      V(K)=V(K)+F(I)
      DO 20 J=1,MAXX,2
   20 V(K)=V(K)-AB(J)*EXP(-AB(J+1)*SINLAM(I))
      V(K)=-2.*V(K)*EXP(-AB(K+1)*SINLAM(K))
   30 V(K+1)=-V(K)*SINLAM(K)*AB(K)
      NN=MAXX+1
      DO 10 I=NN,10
   10 V(I)=0
      RETURN
      END
      SUBROUTINE CV2(AB,G)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/CNV/N,SINLAM(30),F(30)
      DIMENSION AB(10)
      MAXX=MIN0(9,N)
      G=0
      DO 30 I=1,N
      T=F(I)
      DO 20 J=1,MAXX,2
   20 T=T-AB(J)*EXP(-AB(J+1)*SINLAM(I))
   30 G=G+T*T
      RETURN
      END
      SUBROUTINE SPGP(SPG)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
C
C                             THIS SR INTERPRETS THE SPACE GROUP SYMBOL
C                           AND GENERATES OPERATORS WHICH SYMOPR USES TO
C                           GENERATE THE FULL SET OF EQUIVALENT
C                           POSITIONS AND OP1 AND SMTRY2 USE TO GENERATE
C                           THE FULL SET OF EQUIVALENT INDICES.
      CHARACTER*1 SPG(20),CHR(25)
      DIMENSION L(4,4),ICO(6,15)
      COMMON /SPG/NSP(2),NCONT(10),FILL(3)
      DIMENSION NDAT(7)
      INTEGER AND,OR,XOR
      AND(I,J) = IAND(I,J)
      OR(I,J) = IOR(I,J)
      XOR(I,J) = IEOR(I,J)
      LODGDF(I,J) = AND( XOR(I,J),307)
    1 FORMAT (20H0THE SPACE GROUP IS ,80A1)
    2 FORMAT (34H1DID YOU PUNCH THE CARD CORRECTLY.,/,
     1 35H ERRORS OF SOME SORT WERE DETECTED.,/,
     2 22H0THE CARD WAS READ AS ,80A1)
   24 FORMAT (34H0A CENTER IS PRESENT, NOT AT 0,0,0)
      DATA NDAT(1),NDAT(2),NDAT(3),NDAT(4),NDAT(5),NDAT(6),NDAT(7)/
     *3,1,2,0,2,1,3/
      DATA CHR(1),CHR(2),CHR(3),CHR(4),CHR(5),CHR(6),CHR(7),CHR(8),
     *CHR(9),CHR(10),CHR(11),CHR(12),CHR(13),CHR(14),CHR(15),CHR(16),
     *CHR(17),CHR(18),CHR(19),CHR(20),CHR(21)/' ','C','B','A','P',
     *'F','I','R','M','N','D','1','2','3','4','5','6','-','/','H','.'/
CDB 2
C     PRINT 8,CHR
C   8 FORMAT (1X25A1)
      WRITE(6,1)SPG
      DO 97 I=1,6
      DO 97 J=1,15
   97 ICO(I,J)=0
      DO 98 I=1,4
      DO 98 J=1,4
   98 L(I,J) = 0
      M2 = 0
      K = 1
      M = 1
      NSP(1) = 0
      NSP(2) = 0
      N = 0
      DO 110 J=1,20
   99 DO 100 I=1,21
      IF ( SPG(J).EQ.CHR(I) ) GO TO 101
  100 CONTINUE
CDB 2
C     PRINT 7,SPG(J),J
C   7 FORMAT (1XA1* IS AN UNRECOGNIZABLE CHARACTER IN COL. *I2)
      GO TO 110
  101 IF ( K+M+I.EQ.3 ) GO TO 110
      IF ( I.EQ.1 ) GO TO 108
      L(M,K) = I
      N = 0
      M = M+1
      IF ( M-4 ) 110,110,108
  108 IF ( N.EQ.1 ) GO TO 110
      N = 1
      M = 1
      K = K+1
      IF ( K.GT.4 ) GO TO 200
  110 CONTINUE
  200 IF ( K.LE.2 ) GO TO 500
CDB 3
C     PRINT 3,N,M,K,J,L
C   3 FORMAT (*0N =*I3*  M =*I3*  K =*I3*  J =*I3/
C    1  * L =*4I4/(4X4I4))
      IF ( L(1,1).GT.8 ) GO TO 500
      J = 1
      I = L(1,1)-1
      GO TO (203,202,201,119,204,205,206),I
  201 NCONT(J) = 576
      GO TO 209
  202 NCONT(J) = 516
      GO TO 209
  203 NCONT(J) = 68
      GO TO 209
  204 NCONT(J) = 576
      J = J+1
      GO TO 202
  205 NCONT(J) = 580
      GO TO 209
  207 K = K-1
      NSP(1) = K+3
      GO TO 210
  206 IF ( L(1,3).EQ.8.OR.L(1,4).EQ.8 ) GO TO 207
      NCONT(J) = 8192
      IF ( L(1,K-1).EQ.20 ) K=K-1
      NSP(1) = K+5
      J = J+1
      GO TO 210
  209 J = J+1
  119 IF ( K-4 ) 120,130,140
  120 IF ( L(1,2).EQ.18 ) GO TO 121
      IF ( L(1,2).EQ.17 ) GO TO 122
      IF ( L(1,2).EQ.14 ) GO TO 123
      IF ( L(1,2).EQ.15 ) GO TO 124
      IF ( L(1,2).EQ.12 ) GO TO 125
      NSP(1) = 2
      NSP(2) = 2
      GO TO 210
  121 IF ( L(2,2).EQ.17 ) GO TO 122
      IF ( L(2,2).EQ.14 ) GO TO 123
      IF ( L(2,2).EQ.15 ) GO TO 124
      IF ( L(2,2).EQ.12 ) GO TO 125
      GO TO 500
  122 NSP(1) = 11
      GO TO 210
  123 NSP(1) = 8
      GO TO 210
  124 NSP(1) = 4
      GO TO 210
  125 NSP(1) = 1
      GO TO 210
  130 IF ( L(1,3).NE.14 ) GO TO 500
      NSP(1) = 13
      GO TO 210
  140 IF ( L(1,3).EQ.14 ) GO TO 151
      IF ( L(1,2).EQ.18 ) GO TO 152
      IF ( L(1,2).EQ.17 ) GO TO 153
      IF ( L(1,2).EQ.14 ) GO TO 154
      IF ( L(1,2).EQ.15 ) GO TO 155
      IF ( L(1,2).EQ.12 ) GO TO 141
      IF ( L(1,3).EQ.12 ) GO TO 142
      IF ( L(1,4).EQ.12 ) GO TO 500
      NSP(1) = 3
      GO TO 210
  141 IF ( L(1,3).EQ.12 ) GO TO 143
      IF ( L(1,4).NE.12 ) GO TO 500
      NSP(1) = 2
      NSP(2) = 2
      GO TO 210
  142 IF ( L(1,4).NE.12 ) GO TO 500
      NSP(1) = 2
      NSP(2) = 1
      GO TO 210
  143 IF ( L(1,4).EQ.12 ) GO TO 500
      NSP(1) = 2
      NSP(2) = 3
      GO TO 210
  151 NSP(1) = 14
      GO TO 210
  152 IF ( L(2,2).EQ.17 ) GO TO 153
      IF ( L(2,2).EQ.14 ) GO TO 154
      IF ( L(2,2).EQ.15 ) GO TO 155
      GO TO 500
  153 NSP(1) = 12
      GO TO 210
  154 IF ( L(1,3).EQ.12 ) GO TO 156
      IF ( L(1,4).NE.12 ) GO TO 500
      NSP(1) = 9
      GO TO 210
  155 NSP(1) = 5
      GO TO 210
  156 IF ( L(1,4).EQ.12 ) GO TO 123
      NSP(1) = 10
  210 K = K-1
CDB 2
C     PRINT 4,K,NSP,J,NCONT
C   4 FORMAT (*0K =*I3*  NSP =*2I4*  J=*I3/* NCONT =*10I4)
      N = 1
      DO 300 M=2,K
      IF ( L(1,M).EQ.0 ) GO TO 500
  218 I = IABS(L(1,M)-5)
  219 IF ( I.LE.0.OR.I.GT.15 ) GO TO 500
C              A   B   C   M   N   D   1   2   3   4   5   6   -   /
      GO TO (220,220,220,220,220,245,250,255,260,265,500,270,275,300,
     1 300),I
C        H
  220 GO TO (500,221,222,223),M
  221 IF ( L(1,3).EQ.14 ) GO TO 2230
      IF ( L(1,2).EQ.15 ) GO TO 2230
      IF ( L(1,2).EQ.17 ) GO TO 2230
      IF ( K.EQ.2 ) GO TO 2220
 2210 ICO(1,N) = 2
      ICO(2,N) = 0
      ICO(3,N) = 0
      ICO(4,N) = 4
      IF ( I.EQ.2.OR.I.EQ.5 ) ICO(5,N) = 1
      IF ( I.EQ.3.OR.I.EQ.5 ) ICO(6,N) = 1
 2211 N = N+1
      IF ( L(1,2).NE.15 ) GO TO 300
      ICO(1,N) = ICO(2,N-1)
      ICO(2,N) = ICO(1,N-1)
      ICO(3,N) = ICO(3,N-1)
      ICO(4,N) = ICO(5,N-1)
      ICO(5,N) = ICO(4,N-1)
      ICO(6,N) = ICO(6,N-1)
      N= N+1
      GO TO 300
  222 IF ( L(1,2).EQ.14.OR.L(1,2).EQ.17 ) GO TO 225
      IF ( L(1,2).EQ.15 ) GO TO 2210
 2220 ICO(1,N) = 0
      ICO(2,N) = 2
      ICO(3,N) = 0
      ICO(5,N) = 4
      IF ( I.EQ.1.OR.I.EQ.5 ) ICO(4,N) = 1
      IF ( I.EQ.3.OR.I.EQ.5 ) ICO(6,N) = 1
      N = N+1
      GO TO 300
  223 IF ( L(1,3).EQ.14.OR.L(1,2).EQ.15 ) GO TO 224
      IF ( L(1,2).EQ.14.OR.L(1,2).EQ.17 ) GO TO 224
 2230 ICO(1,N) = 0
      ICO(2,N) = 0
      ICO(3,N) = 2
      ICO(6,N) = 4
      IF ( I.EQ.1.OR.I.EQ.5 ) ICO(4,N) = 1
      IF ( I.EQ.2.OR.I.EQ.5 ) ICO(5,N) = 1
      N = N+1
      IF ( M.EQ.2.AND.L(1,2).EQ.15.AND.I.EQ.5 ) ICO(4,N-3)=1
      IF ( M.NE. 2.OR.L(1,2).NE.17) GO TO 300
      IF ( L(1,3).EQ.2 ) ICO(6,N-1)=1
      IF ( L(1,4).EQ.2 ) ICO(6,N-1)=MOD(ICO(6,N-1)+1,2)
      GO TO 300
  224 ICO(1,N) = 1
      ICO(2,N) = 1
      ICO(3,N) = 0
      ICO(4,N) = 4
      ICO(5,N) = 4
      IF ( I.EQ.3.OR.I.EQ.5 ) ICO(6,N) = 1
      IF ( NSP(1).EQ.7.AND.I.EQ.3 ) GO TO 2240
      IF ( I.NE.5 ) GO TO 226
 2240 ICO(4,N) = 5
      ICO(5,N) = 5
      N = N+1
      GO TO 300
  225 IF ( NSP(1).EQ.7 ) GO TO 224
      ICO(1,N) = 3
      ICO(2,N) = 3
      ICO(3,N) = 0
      ICO(4,N) = 4
      ICO(5,N) = 4
      IF ( I.EQ.3 ) ICO(6,N) = 1
  226 N = N+1
      GO TO 300
C    D TYPE MIRROR
  245 GO TO (500,246,247,248),M
  246 IF ( K.EQ.2 ) GO TO 247
      ICO(1,N) = 2
      ICO(2,N) = 0
      ICO(3,N) = 0
      ICO(4,N) = 6
      ICO(5,N) = 6
      ICO(6,N) = 6
      N = N+1
      GO TO 300
  247 ICO(1,N) = 0
      ICO(2,N) = 2
      ICO(3,N) = 0
      ICO(4,N) = 6
      ICO(5,N) = 6
      ICO(6,N) = 6
      N = N+1
      GO TO 300
  248 IF ( L(1,2).EQ.15.OR.L(1,3).EQ.14 ) GO TO 249
      ICO(1,N) = 0
      ICO(2,N) = 0
      ICO(3,N) = 2
      ICO(4,N) = 6
      ICO(5,N) = 6
      ICO(6,N) = 6
      N = N+1
      GO TO 300
  249 ICO(1,N) = 1
      ICO(2,N) = 1
      ICO(3,N) = 0
      ICO(4,N) = 6
      ICO(5,N) = 6
      ICO(6,N) = 6
      IF (L(1,3).NE.13) GO TO 226
      ICO(4,N) = 0
      ICO(5,N) = 1
      N = N+1
      GO TO 300
C    1 FOLD ROTATION
  250 IF ( L(2,M).NE.3 ) GO TO 300
      ICO(1,N) = 2
      ICO(2,N) = 2
      ICO(3,N) = 2
      ICO(4,N) = 4
      ICO(5,N) = 4
      ICO(6,N) = 4
      N = N+1
      GO TO 300
  255 GO TO (500,256,257,258),M
C    2 FOLD ROTATION
  256 IF ( K.EQ.2 ) GO TO 2571
 2561 ICO(1,N) = 0
      ICO(2,N) = 2
      ICO(3,N) = 2
      ICO(4,N) = 0
      ICO(5,N) = 4
      ICO(6,N) = 4
      IF ( IABS(L(2,M)-13).EQ.1 ) ICO(4,N) = 1
 2560 N = N+1
      DO 2562 I=2,4
      IF ( L(I,M).EQ.19 ) GO TO 2563
 2562 CONTINUE
      GO TO 300
 2563 IF ( L(I+1,M).LE.1 ) GO TO 500
      I = IABS(L(I+1,M)-5)
      GO TO 219
  257 IF ( L(1,2).EQ.14.OR.L(1,2).EQ.17 ) GO TO 259
 2571 ICO(1,N) = 2
      ICO(2,N) = 0
      ICO(3,N) = 2
      ICO(4,N) = 4
      ICO(5,N) = 0
      ICO(6,N) = 4
      IF ( L(2,M).EQ.12 ) ICO(5,N)=1
      IF ( L(1,2).EQ.15 ) GO TO 2211
      GO TO 2560
  258 IF ( L(1,2).GE.14   ) GO TO 2595
      IF ( L(1,3).EQ.14 ) GO TO 259
 2581 ICO(1,N) = 2
      ICO(2,N) = 2
      ICO(3,N) = 0
      ICO(4,N) = 4
      ICO(5,N) = 4
      ICO(6,N) = 0
      IF ( IABS(L(2,M)-13).EQ.1 ) ICO(6,N) = 1
      IF (      L(2,M).EQ.16    ) ICO(6,N) = 1
      GO TO 2560
  259 IF ( L(1,3).EQ.8.OR.L(1,4).EQ.8 ) GO TO 2595
      ICO(1,N) = 1
      ICO(2,N) = 1
      ICO(3,N) = 2
      ICO(4,N) = 0
      ICO(5,N) = 0
      ICO(6,N) = 4
      GO TO 2560
 2595 IF ( L(1,2).EQ.15)GO TO 259
      ICO(1,N) = 3
      ICO(2,N) = 3
      ICO(3,N) = 2
      ICO(4,N) = 4
      ICO(5,N) = 4
      ICO(6,N) = 4
      GO TO 2560
C    3 FOLD ROTATION
  260 GO TO (500,261,262,500),M
  261 IF ( L(1,1).EQ.8.AND.J.EQ.1 ) GO TO 262
      IX = 0
      IF ( L(2,M).EQ.12 ) GO TO 2611
      IF ( L(2,M).EQ.13 ) GO TO 2612
 2610 NCONT(J) = 8196
      GO TO 2613
 2611 NCONT(J) = 8200
      IF ( L(1,4).NE.13 ) GO TO 2613
      J = J+1
      NCONT(J) = 2321
      IF ( L(1,2).EQ.14 ) NCONT(J)=4403
      L(1,3) = 12
      L(1,4) = 12
      GO TO 2613
 2612 NCONT(J) = 8204
      IF ( L(1,4).NE.13 ) GO TO 2613
      J = J+1
      NCONT(J) = 4369
      IF ( L(1,2).EQ.14 ) NCONT(J)=2355
      L(1,3) = 12
      L(1,4) = 12
 2613 J = J+1
      IF ( IX-1 ) 250,2581,2230
C    CUBIC OR RHOMBOHEDERAL
  262 NCONT(J) = 16384
      IF (L(2,M).NE.3 ) GO TO 2620
      J = J+1
      NCONT(J) = 290
 2620 J = J+1
      IF ( N.EQ.1 ) GO TO 300
      I = N-1
      IN1 = N
      IN2 = N+1
      ICO(1,IN1) = ICO(3,I)
      ICO(2,IN1) = ICO(1,I)
      ICO(3,IN1) = ICO(2,I)
      ICO(4,IN1) = ICO(6,I)
      ICO(5,IN1) = ICO(4,I)
      ICO(6,IN1) = ICO(5,I)
      ICO(1,IN2) = ICO(2,I)
      ICO(2,IN2) = ICO(3,I)
      ICO(3,IN2) = ICO(1,I)
      ICO(4,IN2) = ICO(5,I)
      ICO(5,IN2) = ICO(6,I)
  263 ICO(6,IN2) = ICO(4,I)
      N = IN2+1
      GO TO 300
  265 IF ( M.NE.2 ) GO TO 500
      ICO(1,N) = 3
      ICO(2,N) = 1
      ICO(3,N) = 0
      ICO(4,N) = 4
      ICO(5,N) = 4
      ICO(6,N) = 0
      IF ( L(2,2).EQ.12 ) ICO(6,N) = 2
      IF ( L(2,2).EQ.13 ) ICO(6,N) = 1
      IF ( L(2,2).EQ.14 ) ICO(6,N) = 3
      IF ( L(2,2).EQ. 3 ) ICO(3,N) = 2
      N = N+1
      IF ( L(2,2).EQ.3.AND.L(1,3).EQ.14.AND.L(1,4).EQ.11 ) GO TO 266
      IF ( L(1,3).EQ.14 ) GO TO 2561
      IF ( K.GT.2.OR.L(1,1).NE.7 ) GO TO 2581
      IF ( L(2,2)+L(3,2).NE.12 ) GO TO 2581
      L(2,2) = 0
      ICO(5,N-1) = 1
      GO TO 2581
  266 IF ( L(1,1).NE.7.OR.L(1,2).NE.15 ) GO TO 500
      NCONT(J  ) = 16384
      NCONT(J+1) = 356
      NCONT(J+2) = 834
      NCONT(J+3) = 1177
      J = J+3
      GO TO 410
  270 IF ( M.NE.2 ) GO TO 500
      IX = 1
      IF ( L(2,2).EQ.12 ) GO TO 2611
      IF ( L(2,2).EQ.13 ) GO TO 2612
      IF ( L(2,2).EQ.14 ) GO TO 2610
      IF ( L(2,2).EQ.15 ) GO TO 2611
      IF ( L(2,2).EQ.16 ) GO TO 2612
      IF ( L(2,2).EQ. 3 ) GO TO 271
      GO TO 2610
  271 IX = 2
      GO TO 2610
  275 IF ( M.NE.2 ) GO TO 500
      L(1,2) = L(2,2)
      L(2,2) = 3
      GO TO 218
  300 CONTINUE
      N = N-1
      IJ = J
      IF ( N.GT.0 ) GO TO 301
      J = J-1
      GO TO 410
  301 DO 305 I=1,N
      NCONT(J) = ICO(1,I)+16*ICO(2,I)+128*ICO(3,I)+4*MOD(ICO(4,I),4)
     1 +64*MOD(ICO(5,I),4)+ 512*MOD(ICO(6,I),4)
  305 J = J+1
  306 J = J-1
CDB 4
C     PRINT 5,J,IJ,N,NSP,NCONT
C    1 ,ICO
C   5 FORMAT (*0J =*I3*  IJ =*I3*  N =*I3*  NSP =*2I5/* NCONT =*10I4/
C    1 * ICO =*6I3/(6X6I3))
  310 DO 400 I=IJ,J
      NCI = I-IJ+1
      ICO4 = MOD(ICO(4,NCI),4)
      ICO5 = MOD(ICO(5,NCI),4)
      ICO6 = MOD(ICO(6,NCI),4)
      NI4 = NDAT(ICO4+4)
      NI5 = NDAT(ICO5+4)
      NI6 = NDAT(ICO6+4)
      KJ = I+1
      IF ( AND(NCONT(I),307)-290 ) 320,315,320
  315 IF ( AND(NCONT(I),7884) ) 316,318,316
C   A CENTER IS PRESENT, NOT AT 0,0,0
  316 CONTINUE
      WRITE(6,24)
      GO TO 320
C   A CENTER AT 0,0,0 IS PRESENT
  318 CONTINUE
  320 IF ( KJ.GT.J ) GO TO 400
      DO 390 K=KJ,J
      NCK = K-IJ+1
      KCO4 = MOD(ICO(4,NCK),4)
      KCO5 = MOD(ICO(5,NCK),4)
      KCO6 = MOD(ICO(6,NCK),4)
      NK4 = NDAT(KCO4+4)
      NK5 = NDAT(KCO5+4)
      NK6 = NDAT(KCO6+4)
      NXC = MOD(NI4+NK4,4)
      NYC = MOD(NI5+NK5,4)
      NZC = MOD(NI6+NK6,4)
      MJ = K+1
      LOD = LODGDF(NCONT(K),NCONT(I))
      IF ( LOD.NE.290 ) GO TO 330
C   A CENTER IS GENERATED
      IF ( NXC+NYC+NZC.EQ.0 ) GO TO 330
      IF ( L(1,2).EQ.15.AND.I.EQ.IJ+1 ) GO TO 324
  321 IF ( NXC.EQ.0 ) GO TO 322
      IF ( ICO(4,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NXC)*4
      IF ( ICO(4,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NXC)*4
  322 IF ( NYC.EQ.0 ) GO TO 323
      IF ( ICO(5,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NYC)*64
      IF ( ICO(5,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NYC)*64
  323 IF ( NZC.EQ.0 ) GO TO 325
      IF ( ICO(6,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NZC)*512
      IF ( ICO(6,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NZC)*512
      GO TO 325
  324 L(1,2) = 30
      NIJ = ICO(6,1)
      NIJ = NDAT(NIJ+4)
      NJX = MOD(NIJ+NXC,4)
      NCONT(IJ) = AND(NCONT(IJ),2035)+NDAT(NJX+4)*4
      NCONT(IJ) = AND(NCONT(IJ),1855)+NDAT(NIJ+4)*64
      GO TO 321
  325 CONTINUE
      ICO(4,NCI) = 0
      ICO(4,NCK) = 0
      ICO(5,NCK) = 0
      ICO(5,NCI) = 0
      ICO(6,NCI) = 0
      ICO(6,NCK) = 0
  330 CONTINUE
      ICO4 = MOD(NCONT(I)/4  ,4)
      IKO4 = MOD(NCONT(K)/4  ,4)
      ICO5 = MOD(NCONT(I)/64 ,4)
      IKO5 = MOD(NCONT(K)/64 ,4)
      ICO6 = MOD(NCONT(I)/512,4)
      IKO6 = MOD(NCONT(K)/512,4)
      NI4 = NDAT(ICO4+4)
      NK4 = NDAT(IKO4+4)
      NI5 = NDAT(ICO5+4)
      NK5 = NDAT(IKO5+4)
      NI6 = NDAT(ICO6+4)
      NK6 = NDAT(IKO6+4)
      IF ( MJ.GT.J ) GO TO 390
      DO 380 M=MJ,J
      NCM = M-IJ+1
      MCO4 = MOD(ICO(4,NCM),4)
      MCO5 = MOD(ICO(5,NCM),4)
      MCO6 = MOD(ICO(6,NCM),4)
      NM4 = NDAT(MCO4+4)
      NM5 = NDAT(MCO5+4)
      NM6 = NDAT(MCO6+4)
      LOD1 = LODGDF(LOD,NCONT(M))
      NXC = MOD(NI4+NK4+NM4,4)
      NYC = MOD(NI5+NK5+NM5,4)
      NZC = MOD(NI6+NK6+NM6,4)
      IF ( LOD1.NE.290 ) GO TO 350
       IF  ( L(1,2).EQ.11 ) GO TO 334
      IF ( NXC+NYC+NZC.EQ.0 ) GO TO 380
      IF ( IJ.EQ.1 ) GO TO 331
      IF(NXC +NYC .EQ.0 )GO TO 333
      IF ( L(1,3).EQ.14 ) GO TO 331
      IF ( L(1,2).EQ.15 ) GO TO 331
      IF ( L(1,2).EQ.14 ) GO TO 331
      IF ( L(1,2).EQ.17 ) GO TO 331
      IF ( L(1,2)+L(1,3)+L(1,4).LT.18.AND.L(1,2).NE.9 ) GO TO 331
      NXC = MOD(NCONT(1)/2  +NXC,4)
      NYC = MOD(NCONT(1)/32 +NYC,4)
      NZC = MOD(NCONT(1)/256+NZC,4)
  331 CONTINUE
      IF ( NXC.EQ.0 ) GO TO 332
      IF ( ICO(4,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NXC)*4
      IF ( ICO(4,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NXC)*4
      IF ( ICO(4,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NXC)*4
  332 IF ( NYC.EQ.0 ) GO TO 333
      IF ( ICO(5,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NYC)*64
      IF ( ICO(5,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NYC)*64
      IF ( ICO(5,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NYC)*64
  333 IF ( NZC.EQ.0 ) GO TO 335
      IF ( ICO(6,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NZC)*512
      IF ( ICO(6,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NZC)*512
      IF ( ICO(6,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NZC)*512
      GO TO 335
  334 NCONT(I) = AND(NCONT(I),2035)
      NCONT(K) = AND(NCONT(K),1855)
      NCONT(M) = AND(NCONT(M),511)
  335 ICO(4,NCI) = 0
      ICO(5,NCI) = 0
      ICO(6,NCI) = 0
      ICO(4,NCK) = 0
      ICO(5,NCK) = 0
      ICO(6,NCK) = 0
      ICO(4,NCM) = 0
      ICO(5,NCM) = 0
      ICO(6,NCM) = 0
      GO TO 380
  350 IF ( LOD1.NE.0 ) GO TO 380
CDB 3
C     PRINT 9,LOD1,NXC,NYC,NZC,NI4,NK4,NI5,NK5,NI6,NK6
C   9 FORMAT (* LOD1 = *O10* NXC =*I4* NYC =*I4* NZC =*I4/
C    1 * NI4 =*I3* NK4 =*I3* NI5 =*I3* NK5 =*I3* NI6 =*I3* NK6 =*I3)
      IF ( NXC+NYC+NZC.EQ.0 ) GO TO 359
      IF ( L(1,2).EQ.30 ) GO TO 3500
      IF ( L(1,2).EQ.15 ) GO TO 355
      IF ( L(1,2).EQ.17 ) GO TO 359
      IF ( L(1,2).EQ.13 ) GO TO 351
      IF ( L(1,3).EQ.13 ) GO TO 352
      IF ( L(1,4).EQ.13 ) GO TO 353
      GO TO 500
 3500 IF ( NXC.EQ.0 ) GO TO 359
      IF ( L(4,2).EQ.4 ) GO TO 359
      IF ( NXC.EQ.NK4 ) GO TO 359
      NCONT(K) = OR(NCONT(K),NDAT(NXC)*4)
      IF ( L(1,4).EQ.13.AND.L(2,4).EQ.0 ) GO TO 3580
      GO TO 359
  351 NYC = MOD(NK5+NM5,4)
      NZC = MOD(NK6+NM6,4)
      IF ( L(1,3).EQ.13 ) GO TO 354
      IF ( L(1,3).EQ.14 ) GO TO 354
      IF ( L(1,4).EQ.13 ) GO TO 354
      M2 = I+1
 3511 CONTINUE
      IF(L(2,2).EQ.12.AND.(L(1,3).EQ.9 .OR.L(1,4).EQ.9))  GO TO 360
      IF ( ICO(5,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NYC)*64
      IF ( ICO(5,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NYC)*64
 3510 IF ( NZC.LE.0 ) GO TO 360
      IF ( ICO(6,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NZC)*512
      IF ( ICO(6,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NZC)*512
      GO TO 360
  352 NXC = MOD(NI4+NM4,4)
      NZC = MOD(NI6+NM6,4)
      M2 = K+1
      IF(L(2,3).EQ.12 .AND.(L(1,2).EQ.9 .OR. L(1,4).EQ.9)) GO TO 360
      IF ( NXC.LE.0 ) GO TO 3520
      IF ( ICO(4,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NXC)*4
      IF ( ICO(4,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NXC)*4
 3520 IF ( NZC.LE.0 ) GO TO 360
      IF ( ICO(6,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NZC)*512
      IF ( ICO(6,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NZC)*512
      GO TO 360
  353 NXC = MOD(NI4+NK4,4)
      NYC = MOD(NI5+NK5,4)
      IF(L(2,4).EQ.12 .AND. ( L(1,2).EQ.9.OR.L(1,3).EQ.9)) GO TO 359
      IF ( NXC.LE.0 ) GO TO 3530
      IF ( ICO(4,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NXC)*4
      IF ( ICO(4,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NXC)*4
 3530 IF ( NYC.LE.0 ) GO TO 359
      IF ( ICO(5,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NYC)*64
      IF ( ICO(5,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NYC)*64
      GO TO 359
  354 IF ( NYC.LE.0 ) GO TO 3540
      IF ( IABS(L(2,2)-13).EQ.1 ) NCONT(I)=NCONT(I)+NDAT(NYC)*64
 3540 IF ( NZC.LE.0 ) GO TO 3541
      IF ( ICO(6,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NZC)*512
 3541 IF ( NXC.LE.0 ) GO TO 359
      IF ( L(1,4).EQ.0.OR.L(1,3).EQ.14 ) GO TO 359
      IF ( L(2,4).NE.12 ) NCONT(K)=NCONT(K)+NDAT(NXC)*4
      GO TO 359
  355 L(1,2) = 30
      IF ( L(1,3).EQ.14 ) GO TO 370
      IF ( L(1,3).EQ.13.AND.L(2,3).EQ.12 ) GO TO 3561
      IF ( L(1,1).EQ. 7.AND.L(2,2).EQ.12 ) GO TO 357
      IF ( L(1,1).EQ. 7.AND.L(2,2).EQ.14 ) GO TO 357
      IF ( L(1,1).EQ. 6.AND.L(2,2).EQ.12 ) GO TO 358
      IF ( L(1,1).EQ. 6.AND.L(2,2).EQ.14 ) GO TO 358
      IF ( L(1,1).EQ.7.AND.L(1,3).EQ.13 ) GO TO 3581
      IF ( MOD(NCONT(I),1024).EQ.19 ) GO TO 350
      IF ( NXC+NYC.GT.0 ) GO TO 356
      IF ( NZC.NE.NM6 ) GO TO 359
      IF ( NZC.LE.0 ) GO TO 359
      NCONT(K) = NCONT(K)+NDAT(NZC)*512
      GO TO 359
  356 IF ( L(3,2).EQ.10.OR.L(4,2).EQ.10 ) GO TO 359
      IF ( L(1,3).NE.10 ) GO TO 359
 3561 IF ( L(2,2).EQ.3 ) GO TO 3560
      NCONT(I) = OR(NCONT(I),68)
      GO TO 3580
 3560 IF ( L(1,4).EQ.2 ) NCONT(K)=OR(NCONT(K),512)
      GO TO 359
  357 NCONT(I) = NCONT(I)+64
      IF ( L(3,2).NE.19 ) NCONT(I+1) = NCONT(I+1)-512
      IF ( L(1,4).EQ.11.AND.L(3,2).EQ.19 )NCONT(I) = NCONT(I)+588
      GO TO 3580
  358 NCONT(I) = NCONT(I)+136
 3580 IF ( L(1,3).NE.13 ) GO TO 359
 3581 M2 = K+1
      GO TO 360
  359 M2 = M+1
  360 CONTINUE
      IF ( M2.GT.J ) GO TO 306
CDB 2
C     PRINT 6,M2,I,J,K,M
C   6 FORMAT (*0M2 =*I3*  I =*I3*  J =*I3* K =*I3*  M =*I3)
      DO 365 M1=M2,J
      NCONT(M1-1) = NCONT(M1)
      DO 365 M3=1,6
  365 ICO(M3,M1-1) = ICO(M3,M1)
      GO TO 306
  370 IF ( L(1,4).GT.12 ) GO TO 371
      M2 = I+1
      GO TO 360
  371  CONTINUE
      L(1,2) = 13
      IF ( L(2,2).EQ.12.AND.L(1,1).EQ.5 ) NCONT(I) = NCONT(I)+200
      IF ( L(2,2).EQ.12.AND.L(1,1).EQ.6 ) NCONT(I) = NCONT(I)+136
      IF ( L(2,2).EQ.12.AND.L(1,1).EQ.7 ) NCONT(I) = NCONT(I)+652
      IF ( L(2,2).EQ.13 )                 NCONT(I) = NCONT(I)+68
      IF ( L(2,2).EQ.14 )                 NCONT(I) = NCONT(I)+140
      GO TO 359
  380 CONTINUE
  390 CONTINUE
  400 CONTINUE
      LD = 0
      DO 405 I=1,J
  405 LD = LODGDF(LD,NCONT(I))
      IF ( LD.NE.0 ) GO TO 410
      NCONT(J-1) = NCONT(J)
      J = J-1
  410 CONTINUE
      NCONT(J+1) = 0
CDB 1
C     PRINT 4,K,NSP,J,NCONT
  450 RETURN
  500 WRITE(6,2)SPG
      NSP(2) = 4
      GO TO 450
      END
      SUBROUTINE REFGEN(IPHASE,ZERO,DISP,TRANSP,PREF,PREFOR)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/HKLCTL/KZ(3,24),AZ(24),NCN(70),ICQ,N1,IER,HN
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/REFLS/IREFS(IRS),REFS(IRS,3),MLT(IRS),PHASEN(IRS),ICX(8)
     } ,HALFL(IRS),HALFG(IRS),GAM(IRS)
      REAL LAMDA
      INTEGER H1,H2,H3
      LOGICAL ORH1,ORH2,ORH3
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/SPG/NSPGRP,K,M(10),FILL(3)
      COMMON/CELLX/A,B,C,ALPHA,BETA,GAMMA,AL(3,3)
      DIMENSION PREF(8,3)
      EQUIVALENCE (AL(1,1),ASTAR),(AL(2,2),BSTAR),(AL(3,3),CSTAR),
     *(AL(1,2),BACOSC),(AL(1,3),CACOSB),(AL(2,3),BCCOSA)
      CHARACTER*8 LAU(14)
      DATA LAU(1),LAU(2),LAU(3),LAU(4),LAU(5),LAU(6),LAU(7),LAU(8),
     *LAU(9),LAU(10),LAU(11),LAU(12),LAU(13),LAU(14)
     */'1BAR','2/M','MMM','4/M','4/MMM','3BAR   R','3BAR M R','3BAR',
     *'3BAR M 1','3BAR 1 M','6/M','6/MMM','M3','M3M'/
      SIN1(A)=SIN(A*6.28318531)
      RAD=3.14159265359/360.0
      IF ( K.GT.3 ) STOP 5001
      KXIS=K
      K=1
 1002 N = 0
      J = 0
      I2D = 0
      I3D = 0
      I1D = 1
      I12D = 1
      I13D = 1
      I123D = 1
      I23D = 1
      I2DEL = 1
      I3DEL = 1
      DO 8000 I=1,8
      IF ( M(I).EQ.0 ) GO TO 9000
      IF ( M(I)-8192 ) 8002,8001,8000
 8001 I3DEL = 3
      I1D = 2
      I123D = 3
      GO TO 9000
 8002 IF ( M(I)-576 ) 8004,8003,8004
 8003 I3DEL = 2
      I23D = 2
      GO TO 8000
 8004 IF ( M(I)-516 ) 8008,8009,8008
 8009 I3DEL = 2
      I13D = 2
      GO TO 8000
 8008 IF ( M(I)-68 ) 8012,8013,8012
 8012 IF ( M(I)-580 ) 8015,8016,8015
 8013 I2DEL = 2
      I12D = 2
      GO TO 8000
 8016 I123D = 2
      I3DEL = 2
 8015 CONTINUE
 8000 CONTINUE
 9000 N=J-1
 97   TMIN = (SIN1(THMIN/720.0)/LAMDA(1))**2
      IC = 0
      IF (IPHASE.GE.2) THEN
         DO 4100 IIPHAS=2,IPHASE
4100     IC = IC+ICX(IIPHAS-1)
      END IF
C     IF(IPHASE.EQ.2)IC=ICX(1)
      SMAX = (SIN1(THMAX/720.0)/LAMDA(1))**2
      IF(LAMDA(2).GT.LAMDA(1))TMIN=TMIN*(LAMDA(1)/LAMDA(2))**2
      IF(LAMDA(2).GT.0..AND.LAMDA(2).LT.LAMDA(1))SMAX=SMAX*
     *(LAMDA(1)/LAMDA(2))**2
      CALL OP1
      WRITE(6,36)LAU(NSPGRP)
   36 FORMAT(15H LAUE SYMMETRY ,A8,33H WILL BE USED TO GENERATE INDICES)
      I1MAX=A*2.0*SQRT(SMAX)
      IF ( KXIS.LT.3 ) THEN
        I2MAX=B*2.0*SQRT(SMAX)
        I3MAX=C*2.0*SQRT(SMAX)
      ELSE
        I2MAX = 2.0*C*SQRT(SMAX)
        I3MAX = 2.0*B*SQRT(SMAX)
      END IF
      L1 = NSPGRP
      IF ( L1.GE.13.AND.M(1).EQ.580 ) L1=L1+2
      IF ( I12D+I13D+I23D.NE.5 ) GO TO 2131
      I12D = 2
      I13D = 1
      I23D = 2
      I2DEL = 2
      I3DEL = 2
 2131 IF ( L1.EQ.6 ) I2D=1
      IF ( L1.EQ.7 ) I2D=2
      I3D = I2D
      I1 = -1
 2200 I1 = 1+I1
      IF ( I1-I1MAX ) 2201,2201,2303
 2201 H1 = I1
      IF ( I2D.GT.0 ) I2MAX=I1
      GO TO (2203,2204,2204,2205,2206,2208,2209,2207,2204,2206,2204,
     1 2206,2206,2206,2206,2206),L1
 2203 I2= -MIN0(I2MAX,I1*I2MAX)
      GO TO 2210
 2204 I2 = 0
      GO TO 2210
 2205 I2= MIN0(I1,1)
      GO TO 2210
 2206 I2 = I1
      GO TO 2210
 2207 I2= MIN0(-I1+1,0)
      GO TO 2210
 2208 I2 = -2*I1
      GO TO 2210
 2209 I2 = -I1/2
 2210 I2= I2DEL*(I2/I2DEL)+MOD(I1,I12D)
      GO TO 2221
 2220 I2 = I2DEL+I2
 2221 H2 = I2
      IF ( I2-I2MAX ) 2222,2222,2200
 2222 GO TO (2223,2223,2224,2224,2224,2225,2225,2224,2224,2223,2224,
     1 2224,2226,2227,2236,2235),L1
 2223 I3= -MIN0(I3MAX,(I1+IABS(I2))*I3MAX)
C2223 I3= -MIN0(I3MAX,I1*I3MAX)  (ALLEN MADE THIS CHANGE,REVERTED LATER)
      GO TO 2228
 2224 I3 = 0
      GO TO 2228
 2225 I3 = -I1-I2
      GO TO 2228
 2226 I3= MIN0(I2,I1+I3DEL)
      GO TO 2228
 2227 I3 = I2
 2228 I3= I3DEL*(I3/I3DEL)+MOD(MOD(I1+I1D*I2,I123D)+I123D,I123D) +MOD(I1
     1,I13D)+MOD(I2,I23D)
      IF ( I3D-1 ) 2232,2229,2231
 2229 I3MAX = I1
      IF ( I2-I1 ) 2230,2232,2230
 2230 I3MAX = I3MAX-1
      GO TO 2232
 2231 I3MAX = I2
      GO TO 2232
 2235 I3= I2+MOD(I1,2)
      GO TO 2232
 2236 I3 = I1+2-MOD(I2,2)
      IF ( I1.EQ.I2.AND.MOD(I1,2).EQ.0 ) I3=I1
      GO TO 2232
 2233 I3 = I3DEL+I3
 2232 H3 = I3
      IF ( KXIS.NE.3 ) GO TO 2240
      H3 = I2
      H2 = I3
 2240 CONTINUE
      IF ( I3-I3MAX ) 113,113,2220
  113 SQ=FLOAT(H1*H1)*ASTAR+FLOAT(H2*H2)*BSTAR+FLOAT(H3*H3)*CSTAR
     1+FLOAT(H1*H2)*BACOSC+FLOAT(H1*H3)*CACOSB+FLOAT(H2*H3)*BCCOSA
      SQ=SQ/4.
 2234 IF ( SQ-SMAX ) 3000,3000,2233
 2303 ICX(IPHASE)=IC
      IF (IPHASE.GE.2) THEN
         DO 4101 IIPHAS=2,IPHASE
4101     ICX(IPHASE) = ICX(IPHASE)-ICX(IIPHAS-1)
      END IF
C     IF(IPHASE.EQ.2)ICX(IPHASE)=IC-ICX(1)
      CALL SORT(IPHASE)
      RETURN
 3000 IF ( SQ - TMIN ) 2233,3117,3117
 3117 IF ( IC.GT.IRS-2 ) GO TO 6001
C     NEXT IF BLOCK FOR PHASE WITH DISTINCT ORIENTATION ALONG PREF(K,I)
      IF (PREFOR.GT.99.) THEN
C
        ORH1 = IFIX(PREF(IPHASE,1)).EQ.H1
        IF (.NOT.(ORH1).AND.H1.NE.0.AND.IFIX(PREF(IPHASE,1)).NE.0)
     *     ORH1 = MOD(H1,IFIX(PREF(IPHASE,1))).EQ.0
        IF (.NOT.ORH1) GO TO 2233
C
        ORH2 = IFIX(PREF(IPHASE,2)).EQ.H2
        IF (.NOT.(ORH2).AND.H2.NE.0.AND.IFIX(PREF(IPHASE,2)).NE.0)
     *     ORH2 = MOD(H2,IFIX(PREF(IPHASE,2))).EQ.0
        IF (.NOT.ORH2) GO TO 2233
C
        ORH3 = IFIX(PREF(IPHASE,3)).EQ.H3
        IF (.NOT.(ORH3).AND.H3.NE.0.AND.IFIX(PREF(IPHASE,3)).NE.0)
     *     ORH3 = MOD(H3,IFIX(PREF(IPHASE,3))).EQ.0
        IF (.NOT.ORH3) GO TO 2233
        IORDR1=0
        IORDR2=0
        IORDR3=0
        IF (H1.NE.0) IORDR1 = INT(H1/IFIX(PREF(IPHASE,1)))
        IF (H2.NE.0) IORDR2 = INT(H2/IFIX(PREF(IPHASE,2)))
        IF (H3.NE.0) IORDR3 = INT(H3/IFIX(PREF(IPHASE,3)))
        IF (IORDR1.EQ.IORDR2.AND.IORDR2.EQ.IORDR3) GO TO 9257
        IF (IORDR1.EQ.0.AND.(IORDR2.EQ.IORDR3)) GO TO 9257
        IF (IORDR2.EQ.0.AND.(IORDR3.EQ.IORDR1)) GO TO 9257
        IF (IORDR3.EQ.0.AND.(IORDR1.EQ.IORDR2)) GO TO 9257
        IF (IORDR1.EQ.0.AND.IORDR2.EQ.0) GO TO 9257
        IF (IORDR2.EQ.0.AND.IORDR3.EQ.0) GO TO 9257
        IF (IORDR3.EQ.0.AND.IORDR1.EQ.0) GO TO 9257
      END IF
9257  CONTINUE
C     SEPARATE PHASE FOR ORIENTATION COMPLETE
      KZ(1,1)=H1
      KZ(2,1)=H2
      KZ(3,1)=H3
      AZ(1)=0.0
      IER=0
      CALL SMTRY2
      IF(IER.NE.0)GOTO 2233
      LXN=2
      IF(LAMDA(2).EQ.0..OR.LAMDA(2).EQ.LAMDA(1))LXN=1
      DO 3118 LX1=1,LXN
      SQH=SQ*LAMDA(LX1)*LAMDA(LX1)
C
C
C
C  MODIF LE MANS......................................
C
C
C
      IF(SQH.EQ.0.)SQH=1.0E-10
C
C 
      TAN2=SQH/(1.-SQH)
      IF(SQH.GE.1.)GOTO 3118
      TANX=SQRT(TAN2)
C     SHIFT DUE TO SAMPLE DISPLACEMENT AND TRANSPARENCY
      SHIFT =  DISP*SQRT(1-SQH)+TRANSP*SQRT(1.-(1.-2.*SQH)*(1.-2.*SQH))
      POS=ATAN(TANX)/RAD+ ZERO + SHIFT
      IF(POS.GT.THMAX.OR.POS.LT.THMIN)GOTO 3118
      IC=IC+1
C
C ABSORPTION CORRECTION FOR NEUTRON CASE
C 
      XABS=1.0
      IF(TMV.GE.0.000001.AND.JOBTYP.EQ.2) THEN
        XABS = EXP(-(1.7133-0.0368*SQH)*TMV+(0.0927+0.375*SQH)*TMV*TMV)
      END IF
      PLOR=1./(2.*SQH*SQRT(1.-SQH))*XABS
       IF (INSTR.EQ.4.OR.INSTR.EQ.5) THEN
       PLOR = PLOR * (1-RKK+RKK*(1.-2.*SQH)*(1.-2.*SQH))
       GO TO 4000
       END IF
      IF(JOBTYP.EQ.3)PLOR=PLOR*(1.+(1.-2.*SQH)*(1.-2.*SQH)*CTHM)
      IF(JOBTYP.EQ.1)PLOR=PLOR*(1.+(1.-2.*SQH)*(1.-2.*SQH)*CTHM)
4000   CONTINUE
      IREFS(IC)=256*(256*(256*(8*IPHASE+LX1)+128+H1)+128+H2)+128+H3
      MLT(IC)=MULT(H1,H2,H3)
C      MLT(IC)=MULT(H1,H2,H3,KXIS)  CHANGED TO THE OLD VERSION
C
C------CALCULATE HALFWIDTH FOR PSEUDOVOIGT WITH GAUSS AND LORENTZ
      IF (NPROF.EQ.8) THEN
       HALFG(IC) =    (U*TAN2+V*TANX+W)
      IF (HALFG(IC).GT.0.) THEN
          HALFG(IC) = SQRT(HALFG(IC))
       ELSE
          WRITE (6,3456) POS,IPHASE
          WRITE (7,3456) POS,IPHASE
          STOP 'SQUARE OF FWHM IS NEGATIVE'
3456      FORMAT (3X,'SQUARE OF FWHM NEGATIVE AT TWO-THETA',F8.3,
     }    'FOR PHASE NO. ',I4)
      END IF
       HALFL(IC) = ULOR*TANX+VLOR/SQRT(1.-SQH)
       REFS(IC,1) = (HALFG(IC)**5.+2.69269*HALFG(IC)**4.*HALFL(IC)+
     1 2.42843*HALFG(IC)**3.*HALFL(IC)**2.+
     2 4.47163*HALFG(IC)**2.*HALFL(IC)**3. +
     3 0.07842*HALFG(IC)*HALFL(IC)**4. + HALFL(IC)**5.)**0.2
       TLR = HALFL(IC)/REFS(IC,1)
       GAM(IC) = 1.36603*TLR-0.47719*TLR*TLR+0.11116*TLR**3.
       GO TO 7000
      END IF
      REFS(IC,1)=    (U*TAN2+V*TANX+W)
      IF (REFS(IC,1 ).GT.0.) THEN
          REFS(IC,1)= SQRT(REFS(IC,1))
       ELSE
          WRITE (6,3456) POS,IPHASE
          WRITE (7,3456) POS,IPHASE
          STOP 'SQUARE OF FWHM IS NEGATIVE'
      END IF
7000  REFS(IC,2)=POS
      REFS(IC,3)=PLOR
 3118 CONTINUE
      GOTO 2233
 6001 WRITE(6,24) IRS
      WRITE(7,24) IRS
   24 FORMAT (1X,I4,'TOO MANY REFLECTIONS, INCREASE *IRS* IN THE'
     },'PARAMETER STATEMENT IN THE SOURCE CODE ')
      STOP
C     GO TO 2303
      END
      SUBROUTINE INPTR
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      REAL LAMDA
      INTEGER PTR
      COMMON/DC/SAVE(8,6),NSAVE
      COMMON/REFLS/IREFS(IRS),REFS(IRS,3),FF(IRS),PHASEN(IRS),IC(8)
     } ,HALFL(IRS),HALFG(IRS),GAM(IRS)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      CHARACTER*56 DATAID
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1,SPG(20)*1
      CHARACTER TITLE*70,PHSNM(8)*70
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/SPG/NSP(2),NCONT(10),FILL(3)
      COMMON/BLNK1/NJNK(22),FILL2(751)
      COMMON/COEFF/AC(10,16),POSI(30),SCAT(30),DFP(16),DFPP(16)
      CHARACTER*5 DATE
      CHARACTER*4 NAM(16)
      COMMON/COEFC/NAM
      COMMON/CELLX/AA,B,C,ALPHA,BETA,GAMMA,AL(3,3)
C&    COMMON/CONSTR/CONA(2,16,8),ICON(2,16,8),JCON(2,16,8),LCONI(2,16,8)
C&   *,LCONJ(2,16,8),DF(2,16),LN(2,16)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ)
     *,IWW(IDSZ),NPTS
      DIMENSION XRYZ(5),BACK(6),FBACK(6),MLTT(IRS)
      EQUIVALENCE (MLTT(1),FF(1)),(GLB(1),ZER),(GLB(2),BACK(1))
      EQUIVALENCE (GLB(8),GAM1),(GLB(9),GAM2)
      EQUIVALENCE (GLB(10),DISP),(GLB(11),TRANSP)
      EQUIVALENCE (AGLB(1),FLGZER),(AGLB(2),FBACK(1))
      EQUIVALENCE (AGLB(8),FLGAM1),(AGLB(9),FLGAM2)
      EQUIVALENCE (AGLB(10),FLDISP),(AGLB(11),FLTRNS)
      DATA XRYZ(1),XRYZ(2),XRYZ(3),XRYZ(4),XRYZ(5)
     */2.28962,1.93597,1.54051,0.70926,0.556363/
      READ(5,1,END=99999)TITLE
1001  FORMAT(1X,A70)
   1  FORMAT(BZ,A70)
      READ(5,2,END=99999)JOBTYP,NPROF,NPHASE,NBCKGD,NEXCRG,NSCAT,NORI,
     &IRF,IWGT
   2  FORMAT(BZ,9I4)
      IF(NPHASE.EQ.0)NPHASE=1
      JOBTYP=JOBTYP+1
      NPROF=NPROF+1
      WRITE(6,3)
    3 FORMAT(1HN,/,'1RIETVELD ANALYSIS PROGRAM VERSION DBW3.2S-8711')
      IF(JOBTYP.EQ.1)WRITE(6,4)
   4  FORMAT(15H FOR X-RAY DATA )
      IF(JOBTYP.EQ.2)WRITE(6,5)
      IF(JOBTYP.EQ.3)WRITE(6,6)
    6 FORMAT(25H PATTERN CALCULATION,XRAY  )
      IF(JOBTYP.EQ.4)WRITE(6,7)
    7 FORMAT(28H PATTERN CALCULATION,NEUTRON  )
      IF(JOBTYP.LT.1.OR.JOBTYP.GT.4)STOP 7777
   5  FORMAT(43H FOR NEUTRON DATA, NUCLEAR INTENSITIES ONLY )
      WRITE(8,1001)TITLE
      WRITE(6,1001)TITLE
      WRITE(6,9)NPHASE,NEXCRG,NSCAT
   9  FORMAT(19H NUMBER OF PHASES=  ,I4,/,
     *29H NUMBER OF EXCLUDED REGIONS=  ,I4,/,
     *28H NUMBER OF SCATTERING SETS=  ,I4)
      IF (NORI.EQ.1) WRITE(6,1302)
      IF (NORI.EQ.2) WRITE(6,1303)
1302  FORMAT(1X,'THE MARCH MODEL FOR PREF.OR. WILL BE APPLIED')
1303  FORMAT(1X,'THE PECHARSKII MODEL FOR PREF.OR.WILL BE APPLIED')
      IF(IWGT.EQ.1) WRITE(6,1308)
1308  FORMAT(1X,'MAXIMUN LIKELIHOOD METHOD WILL BE APPLIED')
      IF(NBCKGD-1)110,111,112
 110  WRITE(6,10)
  10  FORMAT(27H BACKGROUND TO BE REFINED   )
      GOTO 113
 111  WRITE(6,11)
  11  FORMAT(37H BACKGROUND DATA TO BE READ FROM FILE )
      GOTO 113
 112  WRITE(6,12)NBCKGD
  12  FORMAT(39H BACKGROUND CORRECTION BY INTERPOLATION  ,
     *12HBETWEEN THE  ,I4,12HPOINTS GIVEN )
 113  WRITE(6,13) NPROF-1
  13  FORMAT(5H THE  ,I4,32HTH PROFILE FUNCTION WAS SELECTED )
      IF(NPROF.EQ.6) WRITE(6,53210)
53210 FORMAT('   THE 4-HW PARAMETER IS X: ETA=ETA0+X*(2THETA)')
      READ(5,14,END=99999)IOT,IPL,IPC,MAT,NXT,LST1,LST2,LST3,IPL1,IPL2
     *                    ,INSTR,JCIL,JSY,JLKH,JFOU
      IF (JSY.EQ.1) WRITE(3,1001)TITLE
      IF (JCIL.EQ.1) WRITE(2,1001)TITLE
      IF (JCIL.EQ.1) WRITE(2,*)NPROF,NPHASE
      DRES = 3.5
      IF (JSY.EQ.1) WRITE(3,9991)IPL1,DRES
 9991 FORMAT(I5,F8.4)
  14  FORMAT(BZ,15I1)
      IF(IOT.NE.0)WRITE(6,15)
  15  FORMAT(46H OUTPUT OBSERVED AND CALCULATED INTENSITIES ON,
     *11H LAST CYCLE )
      IF(IPL.NE.0)WRITE(6,16)
  16  FORMAT(27H GENERATE LINE PRINTER PLOT )
      IF(IPL2.NE.0)WRITE(6,17)
  17  FORMAT(22H GENERATE CALCOMP PLOT )
      IF(IPC.NE.0)WRITE(6,18)
  18  FORMAT(25H OUTPUT STRUCTURE FACTORS )
      IF(MAT.NE.0.AND.JOBTYP.LT.3)WRITE(6,19)
  19  FORMAT(26H OUTPUT CORRELATION MATRIX )
      IF(NXT.NE.0.AND.JOBTYP.LT.3)WRITE(6,20)
  20  FORMAT(24H GENERATE NEW INPUT FILE )
      IF(LST1.NE.0)WRITE(6,21)
  21  FORMAT(22H PRINT REFLECTION LIST )
      IF (INSTR.EQ.1) WRITE(6,1021)
      IF (INSTR.EQ.2) WRITE(6,1022)
      IF (INSTR.EQ.3) WRITE(6,1023)
      IF (INSTR.EQ.4) WRITE(6,1024)
      IF (INSTR.EQ.6) WRITE(6,1025)
      IF (INSTR.EQ.7) WRITE(6,1026)
1021  FORMAT(1X,' DATA FROM D1A,D2B (ILL) ')
1022  FORMAT(1X,' DATA FROM D1B(ILL) STEP=0.2 IN TWO THETA')
1023  FORMAT(1X,' DATA FROM D1B,D20 (NEW FORMAT)')
1024  FORMAT(1X,' DATA FROM BROOKHAVEN SYNCHROTRON ')
1025  FORMAT(1X,' DATA FROM D1A OR D2B PREPARED BY D1A(D2B)SUM ')
1026  FORMAT(1X,' DATA FROM D4 OR D20L ')
      IF(NPHASE.EQ.1)LST3=0
      IF(LST3.NE.0)WRITE(6,8)
    8 FORMAT(29H PRINT MERGED REFLECTION LIST     )
      IF(LST2.NE.0)WRITE(6,22)
  22  FORMAT(21H PRINT CORRECTED DATA )
      READ(5,23,END=99999)LAMDA,RATIO(2),BKPOS,WDT,CTHM,TMV,RLIM,RKK
  23  FORMAT(BZ,9F8.0)
      WRITE(6,24)LAMDA
  24  FORMAT(14H WAVELENGTHS=  ,2F8.4)
      RATIO(1)=1.
      WRITE(6,223)RATIO(2)
 223  FORMAT(23H ALPHA2@DALPHA1 RATIO =  ,F8.4)
      DO 109 IX=1,5
      IF(LAMDA(1)+0.1.GT.XRYZ(IX))GOTO 119
  109 CONTINUE
  119 IXRAY=IX
      WRITE(6,26) WDT
  26  FORMAT(23H BASE OF PEAK = 2.0*HW*,F8.2)
      IF (INSTR.EQ.4) THEN
        WRITE(6,127)CTHM,RKK
      ELSE
        WRITE(6,27)CTHM
      END IF
 127  FORMAT(' COS-MONOCHROMATOR ANGLE= ',F8.4,'POLARIZATION= ',F8.4)
  27  FORMAT(27H MONOCHROMATOR CORRECTION =,F8.4)
      WRITE(6,28)TMV
  28  FORMAT(28H ABSORPTION CORRECTION=-0.1*,F8.4,11H*SIN 2THETA)
      WRITE(6,29)RLIM
  29  FORMAT(43H ASYMMETRY CORRECTION FOR ANGLES LESS THAN ,F8.3,
     *8H DEGREES )
      READ(5,30,END=99999)MCYCLE,EPS,RELAX,THMIN,STEP,THMAX
  30  FORMAT(BZ,1I4,5F4.0,3F8.0)
      IF(JOBTYP.GT.2)MCYCLE=1
      WRITE(6,31)MCYCLE
  31  FORMAT(20H NUMBER OF CYCLES =  ,I4)
      WRITE(6,32)RELAX
  32  FORMAT(19H RELAXATION FACTORS,/,17H FOR COORDINATES=,F5.2,
     */,36H FOR ANISOTRPIC TEMPERATURE FACTORS= ,F5.2,/,
     *26H FOR HALFWIDTH PARAMETERS= ,F5.2,/,
     *23H FOR LATTICE CONSTANTS= ,F5.2)
      WRITE(6,33)EPS
  33  FORMAT(11H EPS-VALUE=,F6.1)
      IF(NBCKGD.LT.2)GOTO 120
      READ(5,34,END=99999)(POS(I),BCK(I),I=1,NBCKGD)
  34  FORMAT(BZ,2F8.2)
      WRITE(6,35)(POS(I),BCK(I),I=1,NBCKGD)
   35 FORMAT(12H BACKGROUND ,/,9H POSITION,4X,9HINTENSITY,/,
     *20(2F9.4,/))
 120  IF(NEXCRG.LE.0)GOTO 122
      READ(5,34,END=99999)(ALOW(I),AHIGH(I),I=1,NEXCRG)
      WRITE(6,37)(ALOW(I),AHIGH(I),I=1,NEXCRG)
  37  FORMAT(18H EXCLUDED REGIONS /5H FROM,5X,2HTO/,20(2F9.4,/))
 122  IF(NSCAT.LE.0)GOTO 124
      DO 125 I=1,NSCAT
      READ(5,38,END=99999)NAM(I),DFP(I),DFPP(I)
 38   FORMAT(BZ,A4,2F8.0)
      IF(JOBTYP.EQ.2.OR.JOBTYP.EQ.4)GOTO 125
      K=0
 126  READ(5,39,END=99999)(AC(J,I),J=1,9)
 39   FORMAT(BZ,9F8.0)
      IF(AC(1,I).EQ.-100.)CALL COEF(I,K)
      IF(AC(3,I).NE.0.)GOTO 125
      K=K+1
      POSI(K)=AC(1,I)
      SCAT(K)=AC(2,I)
      IF(K.LE.29)GOTO126
      WRITE(6,40)
 40   FORMAT(34H TOO MANY SCATTERING TABLE ENTRIES )
      STOP 7700
 125  CONTINUE
      IF(JOBTYP.EQ.1.OR.JOBTYP.EQ.3)GOTO 129
      WRITE(6,422)
 422  FORMAT(19H SCATTERING LENGTHS)
      WRITE(6,423)(NAM(I),DFP(I),I=1,NSCAT)
 423  FORMAT(5H FOR ,A4,5H     ,F10.6)
      DO 424 I=1,NSCAT
      DO 425 J=1,9
 425  AC(J,I)=0.
 424  DFPP(I)=0.
      GOTO 124
 129  WRITE(6,42)
   42 FORMAT(12H FORMFACTORS )
      WRITE(6,41)(NAM(I),DFP(I),DFPP(I),(AC(J,I),J=1,9),I=1,NSCAT)
   41 FORMAT(5H FOR ,A4,5H DFP=,F10.6,6H DFPP=,F10.6,/,
     *14H COEFFICIENTS= ,9F10.6)
  124 CONTINUE
      READ(5,43,END=99999)MAXS
   43 FORMAT(BZ,I8)
C     CHECK DIMENSIONING FOR SOME EQUIVALENCED ARRAYS
      IF (IDSZ.LT.MSZ*MAXS) THEN
       WRITE (6,7989) IDSZ, MSZ,MAXS
       WRITE (7,7989) IDSZ, MSZ,MAXS
7989   FORMAT ('CHANGE IDSZ OR MSZ SO THAT IDSZ IS EQUAL TO OR GREATER',
     } ' THAN MSZ*MAXS',/,
     } 'IDSZ, MAXIMUM NO. OF DATA POINTS = ',I6,/,
     } 'MSZ,  MATRIX SIZE                = ',I6,/,
     } 'MAXS, NO. OF PARAMETERS VARIED   = ',I6,/,
     } '*** JUST A DIMENSIONING ERROR ***'/)
       STOP 'IDSZ IS LESS THAN MSZ*MAXS'
      END IF
C
      IF(JOBTYP.GT.2)MAXS=0
      WRITE(6,44)MAXS
   44 FORMAT(29H NUMBER OF PARAMETERS VARIED= ,I5)
      READ(5,45,END=99999)ZER,FLGZER,GAM1,FLGAM1,GAM2,FLGAM2
     }                   ,DISP,FLDISP,TRANSP,FLTRNS
   45 FORMAT(BZ,10F8.0)
      WRITE(6,46)ZER,FLGZER
   46 FORMAT(32H GLOBAL PARAMETERS AND CODEWORDS ,/,
     *11H ZEROPOINT= ,2F8.2)
      IF(NBCKGD.NE.0)GOTO 49
      READ(5,51,END=99999)BACK,FBACK
   51 FORMAT(BZ,6G12.6)
      WRITE(6,52)BKPOS,BACK,FBACK
   52 FORMAT(36H BACKGROUND PARAMETERS AND CODEWORDS,/
     }' ORIGIN OF BACKGROUND POLYNOMIAL AT TWO-THETA = ',F8.3,'DEGREES'
     } ,/,6G12.6,/,6F12.2)
   49 IF(NPROF.EQ.5)WRITE(6,461)GAM1,FLGAM1,GAM2,FLGAM2
  461 FORMAT(10H SKEWNESS=,2F8.2,/,8H EXCESS=,2F8.2)
C     IF(NPROF.EQ.6)WRITE(6,462)GAM1,FLGAM1
C 462 FORMAT(6H  ETA=,2F8.2)
C     IF(NPROF.EQ.7)WRITE(6,463)GAM1,FLGAM1
C 463 FORMAT(11H PEARSON-M=,2F8.2)
      WRITE (6,7100) DISP,FLDISP,TRANSP,FLTRNS
7100  FORMAT (1X,'DISPLACEMENT PEAKSHIFT PARAMETER AND CODEWORD',2F8.2
     },/,' TRANSPARENCY PEAKSHIFT PARAMETER AND CODEWORD',2F8.2)
      IF(JOBTYP.GT.2)THEN
       NPTS=(THMAX-THMIN)/STEP+1.5
       GOTO 483
      END IF
      CALL LECTURE
C      IF(JOBTYP.EQ.1.AND.INSTR.EQ.2) GOTO 501
C      IF(JOBTYP.EQ.2.AND.INSTR.EQ.2) GOTO 601
C      READ(4,471,END=99998)THMIN,STEP,THMAX,DATAID
C 471  FORMAT(BZ,3F8.2,A56)
C      WRITE (6,7967) DATAID
C7967  FORMAT (5X,'DATA ID ',A56)
C      NPTS=(THMAX-THMIN)/STEP+1.5
C      IF (NPTS.GT.IDSZ) THEN
C         WRITE(6,1000) IDSZ,NPTS
C         WRITE (7,1000) IDSZ,NPTS
1000     FORMAT(1X,'PROGRAM CAN HANDLE ',I5,'POINTS',/,
     }    1X,I5,' POINTS WERE INPUT',/,
     }   ' INCREASE IDSZ IN PARAMETER STATEMENT')
C         STOP ' TOO MANY DATA POINTS '
C      ENDIF
C      READ(4,472,END=99998)(Y(I),I=1,NPTS)
 472  FORMAT(BZ,8(F7.0,1X))
C       DO 4484 I=1,NPTS
C4484   VAR(I) = Y(I)
C      GOTO 484
CC
CC       READ DATA FROM SYNCHROTRON SOURCE AND CORRECT DATA FOR DEAD TIME
CC      CALCULATE VARIANCE FOR EACH OF THE DATA POINTS
CC     DATE IS OCT85,FEB86,AUG86
CC     NRANGE IS THE NO OF BLOCKS IN WHICH THE DATA ARE GIVEN
CC     OFSTI0 - DARK BEAM CURRENT, READING WITH NO ELECTRONS IN THE CHAMB
CC     OFSTI1 - DETECTOR DARK BEAM CURRENT
CC     CHMBRI - ALL CURRENTS ARE  NORMALISED TO CHMBRI
C501   READ (4,796) DATE,DATAID
C796   FORMAT(A5,A56)
C      WRITE (6,7967) DATAID
C      READ (4,502,END=99998) NRANGE,CHMBRI,TAUK
C502   FORMAT (BZ,I8, F8.0,G10.0)
CC
CC     NPTS IS THE COUNTER FOR TOTAL NO OF POINTS IN ALL THE RANGES
C      NPTS = 0
C      DO 530 J=1,NRANGE
CC     READ INFORMATION ABOUT EACH RANGE
C      READ (4,500,END=99998) ANGMIN,STEP,ANGMAX,STPTIM,OFSTI0,OFSTI1
C500   FORMAT (BZ,6F8.0)
CC
C      IPTS= (ANGMAX-ANGMIN)/STEP +1.5
CC     FIND MAXIMUM AND MINIMUM TWO THETA IN ALL RANGES
C      IF (J.EQ.1) THMIN = ANGMIN
C      IF (J.EQ.NRANGE) THMAX = ANGMAX
CC
C       IF (J.GT.1) THEN
C        READ (4,510)
C        IPTS = IPTS - 1
C       END IF
C      IF (NPTS+IPTS.GT.IDSZ) THEN
C         WRITE(6,1000) IDSZ,NPTS+IPTS
C         WRITE (7,1000) IDSZ,NPTS+IPTS
C         STOP ' TOO MANY DATA POINTS '
C      ENDIF
CC     VAR(I) IS USED FOR TWO QUANTITIES, JUST TO SAVE SOME SPACE.
C      IF (DATE.EQ.'OCT85') THEN
C       READ (4,510,END=99998) (Y(I+NPTS),VAR(I+NPTS),I=1,IPTS)
C      ELSE IF (DATE.EQ.'FEB86') THEN
C       READ (4,511,END=99998) (Y(I+NPTS),VAR(I+NPTS),I=1,IPTS)
C      ELSE IF (DATE.EQ.'AUG86') THEN
C       READ (4,512,END=99998) (VAR(I+NPTS),Y(I+NPTS),I=1,IPTS)
C      ELSE
C       WRITE (6,513)
C      END IF
C510   FORMAT (BZ,24X,F7.0,1X,F7.0)
CC     USE THIS FOR DATA TAKEN IN FEB 86
C511   FORMAT (BZ,24X,F7.0,1X,F7.0)
C     USE THIS FOR DATA TAKEN IN AUG 86
C512   FORMAT (BZ,51X,F10.0,1X,F10.0)
C513   FORMAT (5X,'WHEN WAS THIS DATA TAKEN. OCT85,FEB86 OR AUG86')
CC     TAUK = 2.4621E-6
C      DO 520 I=NPTS+1,IPTS+NPTS
C      Y(I) = Y(I)/STPTIM
C      FLEET1 = VAR(I)-OFSTI0
C      FLEET2= FLEET1/CHMBRI
C      FLEET2= (FLEET2*STPTIM*(1-TAUK*Y(I)))**2.
C      VAR(I) = (STPTIM*Y(I))/FLEET2
C      Y(I) = (Y(I)/(1-TAUK*Y(I))-OFSTI1)*CHMBRI/FLEET1
C      IF (ABS(Y(I)).LT.0.01) Y(I)=1.
C520   CONTINUE
C530   NPTS=NPTS+IPTS
C       GOTO 484
CC       ENDS SYNCHROTRON DATA MODIFICATION
CC     BEGIN VARIANCE CALCULATION FOR VARYING NO. OF COUNTERS AT EACH STE
C601   READ (4,471,END=99998) THMIN,STEP,THMAX,DATAID
C      WRITE (6,7967) DATAID
C      NPTS = (THMAX-THMIN)/STEP+1.5
C      IF (NPTS.GT.IDSZ) THEN
C         WRITE(6,1000) IDSZ,NPTS
C         WRITE (7,1000) IDSZ,NPTS
C         STOP ' TOO MANY DATA POINTS '
C      ENDIF
C      READ (4,602,END=99998) (VAR(I),Y(I),I=1,NPTS)
C602   FORMAT (10(F2.0,F6.0))
C      DO 603 I=1,NPTS
C603   VAR(I)=Y(I)/VAR(I)
C      GO TO 484
CC
 483  CONTINUE
      IF (NPTS.GT.IDSZ) THEN
         WRITE(6,1000) IDSZ,NPTS
         WRITE (7,1000) IDSZ,NPTS
         STOP ' TOO MANY DATA POINTS '
      ENDIF
  484 IF(NBCKGD-1)474,475,476
  474 TH=THMIN-STEP
      DO 473 I=1,NPTS
      TH=TH+STEP
      THX=TH/BKPOS-1.
      BK(I)=BACK(1)
      DO 473 J=2,6
  473 BK(I)=BK(I)+BACK(J)*THX**(J-1)
      GOTO 477
 475  READ(3,472,END=99997)(BK(I),I=1,NPTS)
      GOTO 477
 476  DIFB=POS(1)-THMIN
      IF(DIFB)4760,4761,4761
 4761 NBX=DIFB/STEP+2.5
      DO 4762 I=1,NBX
 4762 BK(I)=BCK(1)
      NXX=1
      GOTO 4764
 4760 NBX=(POS(2)-THMIN)/STEP+1.5
      BK(1)=BCK(1)-DIFB/(POS(2)-POS(1))*(BCK(2)-BCK(1))
      BSTEP=STEP/(POS(2)-POS(1))*(BCK(2)-BCK(1))
      DO 4763 I=2,NBX
 4763 BK(I)=BK(I-1)+BSTEP
      NXX=2
 4764 NBC=NBCKGD-1
      IF(POS(NBCKGD).GE.THMAX)GOTO 4767
      POS(NBCKGD+1)=THMAX
      BCK(NBCKGD+1)=BCK(NBCKGD)
      NBC=NBC+1
 4767 DO 4765 J=NXX,NBC
      BSTEP=STEP*(BCK(J+1)-BCK(J))/(POS(J+1)-POS(J))
      NINC=(POS(J+1)-POS(J))/STEP+1.5
      N2X=MIN0(NPTS,NBX+NINC)
      DO 4766 I=NBX,N2X
 4766 BK(I)=BK(I-1)+BSTEP
      NBX=N2X
      IF(NBX.EQ.NPTS)GOTO 477
 4765 CONTINUE
C
C
C  MODIF LE MANS : BACKGROUND SUBSTRACTED
C
C
 477  IF(NBCKGD.LT.2)GO TO 478
	DO 4771 J=1,NPTS
	Y(J)=Y(J)-BK(J)
        IF(Y(J).LT.0.000001)Y(J)=0.000001
4771	BK(J)=0.
C
C
C   END OF MODIF
C
C
C
478   DO 4100 K=1,NPHASE
4100  IC(K)=0
      DO 81 K=1,NPHASE
      READ(5,465,END=99999)PHSNM(K)
  465 FORMAT(BZ,A70)
      WRITE(6,47)K,PHSNM(K)
   47 FORMAT(7H1PHASE  ,I2,/,1X,A70)
      READ(5,48,END=99999)NATOM(K),NEQC(K),NINEQC(K),(PREF(K,I),I=1,3)
      N=NATOM(K)
      WRITE(6,480)N,NEQC(K),NINEQC(K),(PREF(K,I),I=1,3)
  480 FORMAT(18H NUMBER OF ATOMS= ,I4,/,20H NUMBER OF EQUALITY ,
     *13HCONSTRAINTS= ,I4,34H NUMBER OF INEQUALITY CONSTRAINTS= ,I4,
     *31H PREFERRED ORIENTATION VECTOR=  ,3F8.4)
   48 FORMAT(BZ,3I4,3F4.0)
      READ(5,460,END=99999)(SYMB(K,I),I=1,20)
  460 FORMAT(BZ,20A1)
      DO 135 I=1,20
  135 SPG(I)=SYMB(K,I)
      CALL SPGP(SPG)
C-----READ AND PRINT FOR EACH ATOM
      IOF=0
      IF(K.GT.1) THEN
       DO 4325 IIPHAS=2,K
4325   IOF = IOF + NATOM(IIPHAS-1)
      END IF
      WRITE(6,57)
      READ(5,65,END=99999)(ATEXT(I+IOF),NTYP(I+IOF),
     } (XL(I+IOF,J),J=1, 5), (A(I+IOF,J),J=1, 5),
     } (XL(I+IOF,J),J=6,11), (A(I+IOF,J),J=6,11),
     }    I=1,N)
   65 FORMAT(BZ,2A4,8X,5F8.5,/,16X,5F8.2,/,6F8.5,/,6F8.2)
      WRITE(6,170)(ATEXT(I+IOF),NTYP(I+IOF),(XL(I+IOF,J),J=1,11),I=1,N)
  170 FORMAT(1X,A4,1X,A4,12X,5F10.5/22X,6F10.5)
C     READ(5,861,END=99999)((A(I+IOF,J),J=1,11),I=1,N)
C 861 FORMAT(BZ,5F8.2,/,6F8.2)
C     READ(5,50,END=99999) PAR(K,1),PAR(K,17),(PAR(K,I),I=2,16)
      READ(5,50,END=99999) PAR(K,1),PAR(K,17),PAR(K,2),
     }                     APAR(K,1),APAR(K,17),APAR(K,2),
     } PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,15),PAR(K,16),
     } APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,15),APAR(K,16),
     } (PAR(K,I),I=6,11), (APAR(K,I),I=6,11),
     } PAR(K,12),PAR(K,13),PAR(K,14),
     } APAR(K,12),APAR(K,13),APAR(K,14)
   50 FORMAT(BZ,G8.2,F8.0,F8.0,/,3F8.2,/5F8.0,/,5F8.2,/,6F8.0,/,6F8.2,/,
     } 3F8.0,/,3F8.2)
C     WRITE(6,66) PAR(K,1),PAR(K,17),(PAR(K,I),I=2,16)
      WRITE(6,66) PAR(K,1),PAR(K,17),PAR(K,2),
     } PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,15),PAR(K,16),
     } (PAR(K,I),I=6,11),
     } PAR(K,12),PAR(K,13),PAR(K,14)
   66 FORMAT(' OVERALL SCALE FACTOR=',G12.6,/,
     * ' ETA (PSEUDO-VOIGT) OR M (PEARSON VII) = ' ,F8.4,/,
     * ' OVERALL TEMP. FACTOR=',
     *F12.5,/,' HALFWIDTH PARAMETERS=',5F12.4,/,' DIRECT CELL PARAMETERS
     *=',6F9.4,/,' PREFERRED ORIENTATION PARAMETERS=',2F7.3,/,
     *' ASYMMETRY PARAMETER=',F8.6,/)
      AA=PAR(K,6)
      B=PAR(K,7)
      C=PAR(K,8)
      ALPHA=PAR(K,9)
      BETA=PAR(K,10)
      GAMMA=PAR(K,11)
      CALL CELL2
      DO 72 I=1,6
   72 SAVE(K,I)=PAR(K,I+5)
      DO 73 I=1,3
   73 PAR(K,I+5)=AL(I,I)
      PAR(K,9)=AL(2,3)
      PAR(K,10)=AL(1,3)
      PAR(K,11)=AL(1,2)
      WRITE(6,82)
C-----PRINT CODEWORDS FOR ATOMIC PARAMETERS
      WRITE(6,85)(ATEXT(I+IOF),(A(I+IOF,J),J=1,11),I=1,N)
   85 FORMAT(1X,A4,17X,5F10.2/22X,6F10.2)
      DO 83 I=1,N
      DO 84 J=1,11
      X=A(I+IOF,J)
      IYY=INT(ABS(X)/10.)
      IF(IYY.GT.MSZ) GO TO 99996
      LP(I+IOF,J)=IYY
   84 A(I+IOF,J)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
   83 CONTINUE
C-----PRINT CODEWORDS FOR PROFILE PARAMETERS
C     READ(5,68,END=99999) APAR(K,1),APAR(K,17),(APAR(K,I),I=2,16)
C  68 FORMAT(F8.2,F8.2,F8.2,/,3F8.2,/,6F8.2,/,3F8.2,/,2F8.2)
C     WRITE(6,89) APAR(K,1),APAR(K,17),(APAR(K,I),I=2,16)
      WRITE(6,89)  APAR(K,1),APAR(K,17),APAR(K,2),
     } APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,15),APAR(K,16),
     } (APAR(K,I),I=6,11),
     } APAR(K,12),APAR(K,13),APAR(K,14)
   89 FORMAT(' OVERALL SCALE FACTOR=',F8.2,/,
     * ' ETA (PSEUDO-VOIGT) OR M (PEARSON VII) = ',F8.2,/,
     *' OVERALL TEMP. FACTOR=',F8.2,/,
     *' HALFWIDTH PARAMETERS=',5F8.2,/,
     *' CELL CONSTANTS=',6F8.2,/,
     *' PREFERRED ORIENTATION PARAMETERS=',2F8.2,/,
     *' ASYMMETRY PARAMETER=',F8.2,/)
      DO 87 I=1,17
      X=APAR(K,I)
      IYY=INT(ABS(X)/10.)
      LPAR(K,I)=IYY
   87 APAR(K,I)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
C-----READ CONSTRAINTS
      MAXCON=NEQC(K)+NINEQC(K)
 151  CALL LOOKUP(K,NATOM(K),NSCAT,IXRAY,JOBTYP)
      U=PAR(K,3)
      V=PAR(K,4)
      W=PAR(K,5)
      IF (NPROF.EQ.8) THEN
      ULOR=PAR(K,15)
      VLOR=PAR(K,16)
      END IF
C
C  SWICHT TO GENERATION OR READING THE BRAGG REFLECTIONS
C
      IF(IRF.EQ.0) THEN
            CALL REFGEN(K,ZER,DISP,TRANSP,PREF,PAR(K,12))
        ELSE
            CALL REFLEC(K,ZER,DISP,TRANSP,PREF,PAR(K,12))
      ENDIF
      CALL RTMT(IPL1,K)
      ICY=1
      ICZ=0
      DO 4101 IIPHAS=1,K
4101  ICZ = ICZ + IC(IIPHAS)
      IF(K.GE.2) ICY=1+ICZ-IC(K)
      IF(LST1.NE.1)GOTO 479
      IXDEL=0
      DO 481 IXX=ICY,ICZ
      IX=IXX-IXDEL
      IRL=MOD(IREFS(IXX),256)-128
      IRK=MOD(IREFS(IXX)/256,256)-128
      IRH=MOD(IREFS(IXX)/256/256,256)-128
      IRC=MOD(IREFS(IXX)/256/256/256,8)
      IF (NPROF.EQ.8) THEN
      IF(MOD(IX-1,60).EQ.0)WRITE(6,7482)
      WRITE(6,7470)IX,IRC,IRH,IRK,IRL,MLTT(IXX),(REFS(IXX,JX),JX=1,3)
     +, HALFL(IXX), HALFG(IXX),GAM(IXX)
 7482  FORMAT(38H1NO.  CODE    H   K   L  MULT   HW     ,
     *16HPOSN      FACTOR,'       HWL       HWG     ETA '/)
 7470  FORMAT(1X,2I4,3X,3I4,I6,2F8.3,F10.6,3F8.3)
      GO TO 481
      END IF
      IF(MOD(IX-1,60).EQ.0)WRITE(6,482)
      WRITE(6,470)IX,IRC,IRH,IRK,IRL,MLTT(IXX),(REFS(IXX,JX),JX=1,3)
 482  FORMAT(38H1NO.  CODE    H   K   L  MULT   HW     ,
     *16HPOSN      FACTOR/)
481   CONTINUE
 470  FORMAT(1X,2I4,3X,3I4,I6,2F8.3,F10.6)
  479 DO 499 IX=ICY,ICZ
  499 REFS(IX,3)=REFS(IX,3)*FLOAT(MLTT(IX))
   81 CONTINUE
      DO 88 I=1,11
      X=AGLB(I)
      IYY=INT(ABS(X)/10.)
      LGLB(I)=IYY
   88 AGLB(I)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
   57 FORMAT(/25H ***INITIAL PARAMETERS***/23H ATOM  NTYP            ,6X
     1,1HX,9X,1HY,9X,1HZ,9X,1HB,9X,1HN,/,27X,3HB11
     2,7X,3HB22,7X,3HB33,7X,3HB12,7X,3HB13,7X,3HB23)
   67 FORMAT(BZ,4F8.2)
   76 FORMAT(16H CELL CONSTANTS=,6F12.8)
   77 FORMAT(BZ,2F8.4)
   82 FORMAT(26H0***CODING OF VARIABLES***/5H ATOM,24X,1HX,9X,1HY,9X,1HZ
     1,9X,1HB,9X,1HN,/27X,3HB11,7X,3HB22,7X,
     2 3HB33,7X,3HB12,7X,3HB13,7X,3HB23)
   86 FORMAT(BZ,8F8.2)
      IF (JOBTYP.GT.2) RETURN
C     CHECK FOR HOLES IN THE NORMAL MATRIX
      ISTOP=0
      NATOMS = 0
      DO 7150 K=1,NPHASE
7150  NATOMS = NATOMS + NATOM(K)
      DO 7200 I=1,MAXS
C
      DO 7201 J =1,11
      IF (I.EQ.LGLB(J)) GO TO 7200
7201  CONTINUE
C
      DO 7202 K=1,NPHASE
      DO 7202 J=1,17
      IF(I.EQ.LPAR(K,J)) GO TO 7200
7202  CONTINUE
C
      DO 7203 K=1,NATOMS
      DO 7203 J=1,11
      IF(I.EQ.LP(K,J)) GO TO 7200
7203  CONTINUE
      WRITE (7,7204) I
      WRITE (6,7204) I
7204  FORMAT (5X,'***** HOLE IN THE MATRIX ******. ELEMENT ',I3,1X,
     }'IN THE NORMAL MATRIX IS MISSING')
      ISTOP = 1
7200  CONTINUE
      IF (ISTOP.EQ.1) STOP 'HOLE IN THE MATRIX'
C     END CHECKING FOR HOLE IN THE NORMAL MATRIX
C     CHECK FOR NON-ZERO COUNTS AT ALL POINTS
      DO 5678 I=1,NPTS
      IF (VAR(I).LE.1.0E-6) THEN
        ANGLEP = THMIN + FLOAT(I-1) * STEP
        WRITE (6,5679) I,ANGLEP
        WRITE (7,5679) I,ANGLEP
5679    FORMAT (5X,'ZERO COUNTS AT STEP NO.',I7,'  AT TWO THETA ',F8.3)
        STOP '*** ZERO COUNTS IN DATA FILE AT A STEP ***'
      ENDIF
5678  CONTINUE
      RETURN
99999 STOP 'END OF FILE TAPE5'
99998 STOP 'END OF FILE TAPE4'
99997 STOP 'END OF FILE TAPE3'
99996 STOP 'MATRIX SIZE IS TOO SMALL'
      END



      SUBROUTINE LECTURE
C-----------------------------------------------------------------------
C
C-----------------------------------------------------------------------
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      REAL      LAMDA
      INTEGER   PTR
      COMMON    /DC/SAVE(8,6),NSAVE
      COMMON    /REFLS/IREFS(IRS),REFS(IRS,3),FF(IRS),PHASEN(IRS),
     *                 IC(8),HALFL(IRS),HALFG(IRS),GAM(IRS)
      COMMON    /G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,
     *              RLIM,BKPOS,WDT,ULOR,VLOR
      COMMON    /CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,
     *                  LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,
     *                  NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON    /FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),
     *                   TXT3(20)
      COMMON    /PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),
     *                  APAR(8,20),LPAR(8,20),XL(NATS,11),
     *                  LP(NATS,11),A(NATS,11),PTR(NATS),
     *                  RELAX(4),RATIO(2)
      CHARACTER ATEXT(NATS)*4,NTYP(NATS)*4
      CHARACTER DATAID*56
      COMMON    /PARAC/ATEXT,NTYP
      COMMON    /JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *               NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),
     *               NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1,SPG(20)*1
      CHARACTER TITLE*70,PHSNM(8)*70
      COMMON    /CHAR/SYMB,TITLE,PHSNM
      COMMON    /SPG/NSP(2),NCONT(10),FILL(3)
      COMMON    /BLNK1/NJNK(22),FILL2(751)
      COMMON    /COEFF/AC(10,16),POSI(30),SCAT(30),DFP(16),DFPP(16)
      CHARACTER DATE1*5
      CHARACTER NAM(16)*4
      COMMON    /COEFC/NAM
      COMMON    /CELLX/AA,B,C,ALPHA,BETA,GAMMA,AL(3,3)
C&    COMMON    /CONSTR/CONA(2,16,8),ICON(2,16,8),JCON(2,16,8),
C&   *                  LCONI(2,16,8),LCONJ(2,16,8),DF(2,16),LN(2,16)
      COMMON    /DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ),
     *                 IWW(IDSZ),NPTS
      COMMON    /LATI/LATT(2)
      DIMENSION XRYZ(5),BACK(6),FBACK(6),MLTT(IRS)
      DIMENSION VOLT(5)
      CHARACTER JDATE*18,NOEXP*10,P1A*72
      EQUIVALENCE (MLTT(1),FF(1)),(GLB(1),ZER),(GLB(2),BACK(1))
      EQUIVALENCE (GLB(8),GAM1),(GLB(9),GAM2)
      EQUIVALENCE (GLB(10),DISP),(GLB(11),TRANSP)
      EQUIVALENCE (AGLB(1),FLGZER),(AGLB(2),FBACK(1))
      EQUIVALENCE (AGLB(8),FLGAM1),(AGLB(9),FLGAM2)
      EQUIVALENCE (AGLB(10),FLDISP),(AGLB(11),FLTRNS)
      DATA XRYZ(1),XRYZ(2),XRYZ(3),XRYZ(4),XRYZ(5)
     */2.28962,1.93597,1.54051,0.70926,0.556363/
      WRITE(6,1)
      DO 1000 I=1,IDSZ
 1000 IWW(I)=1
      IF (INSTR.EQ.0) THEN
*
* FIRST USUAL LECTURE
*
         READ(4,*,END=99998)THMIN,STEP,THMAX
         NPTS = (THMAX-THMIN)/STEP+1.5
         IF (NPTS.GT.IDSZ) THEN
            WRITE(6,2)IDSZ,NPTS
            WRITE(7,2)IDSZ,NPTS
            STOP 'DATA OVERFLOW'
         END IF
         READ(4,*,END=99998)(Y(I),I=1,NPTS)
         DO 100 I=1,NPTS
           VAR(I) = Y(I)
  100    CONTINUE
         IF (JCIL.EQ.1) WRITE(2,7)NUMOR,INUM,TS
      ELSE IF (INSTR.EQ.1) THEN
*
* DATA FROM D1A,D2B(ILL) OLD FORMAT
*
         READ(4,*,END=99998)THMIN,STEP,THMAX
         NPTS = (THMAX-THMIN)/STEP+1.5
         READ(4,3,END=99998)(IWW(I),Y(I),I=1,NPTS)
         DO 4 I=1,NPTS
           IF (Y(I).LE.0.00001) Y(I) = 1.0
           IF (IWW(I).EQ.0) IWW(I) = 1
           VAR(I) = Y(I)/FLOAT(IWW(I))
    4    CONTINUE
         IF (JCIL.EQ.1) WRITE(2,7)NUMOR,INUM,TS
      ELSE IF (INSTR.EQ.2) THEN
*
* DATA FROM D1B(ILL) OLD FORMAT
*
         READ(4,5,END=99998)DATE
         WRITE(6,6)DATE
         READ(4,5,END=99998)TXT1
         READ(4,*,END=99998)IO,NUMOR
         WRITE(6,10)NUMOR,TXT1
         TS = FLOAT(NUMOR)
         INUM = 1
         IF (JCIL.EQ.1) WRITE(2,7)NUMOR,INUM,TS
         WRITE(8,7)NUMOR,INUM,TS
         READ(4,5,END=99998)TXT2
         READ(4,5,END=99998)TXT3
         J = 0
         READ(4,8,END=99998)A1,(Y(J+NO),NO=1,10)
         J = J+10
         DO 9 I=2,40
           READ(4,8,END=99998)AAA,(Y(J+NO),NO=1,10)
           J = J+10
    9    CONTINUE
         Y(1) = Y(2)
         Y(400) = Y(399)
         THMIN = 2.0*A1
         STEP = 0.2
         NPTS = 400
         THMAX = THMIN+399*STEP 
         DO 101 I=1,NPTS
           VAR(I) = Y(I)
  101    CONTINUE
      ELSE IF (INSTR.EQ.3) THEN
*
* DATA FROM D1B,D20 NEW FORMAT
*
         READ(4,11,END=99998)NSET
         READ(4,12,END=99998)JDATE,NOEXP,P1A
         READ(4,13,END=99998)NSET1,NUMOR,NSUMAD
         READ(4,14,END=99998)XM,TI,X0,OME,CHI,PHI,TR1,TR2,STEP
     *                       ,TSET,TCONS,TSAMP
         WRITE(6,14)XM,TI,X0,OME,CHI,PHI,TR1,TR2,STEP,TSET,TCONS,TSAMP
         THMIN = X0
         READ(4,15)NPTS,(VOLT(NV),NV=1,5),NUMC1,NUMC2
         WRITE(6,15)NPTS,(VOLT(NV),NV=1,5),NUMC1,NUMC2
         WRITE(6,16)NUMOR,NSUMAD,TSAMP
         IF (JCIL.EQ.1) WRITE(2,37)NUMOR,NSUMAD,TSAMP,TSET,TCONS
     &                 ,OME,CHI,PHI,TR1,TR2,(VOLT(NV),NV=1,5)
         WRITE(8,7)NUMOR,NSUMAD,TSAMP
         J = 0
         NPUNT = NINT(FLOAT(NPTS)/10.)
         WRITE(6,17)NPUNT
         THMAX = THMIN+(NPTS-1)*STEP
         DO 18 I=1,NPUNT
           READ(4,19,END=99998)(IWW(J+NO),Y(J+NO),NO=1,10)
           J = J+10
   18    CONTINUE
         READ(4,20,END=99998)INUM
         DO 21 I=1,NPTS
           IF (Y(I).LE.0.00001) Y(I) = 1.0
           IF (IWW(I).LE.0) IWW(I) = 1
           VAR(I) = Y(I)/FLOAT(IWW(I))
   21    CONTINUE
      ELSE IF (INSTR.EQ.4) THEN
*
* DATA FROM N.L.S (BROOKHAVEN) SYNCHROTRON RADIATION
*
         READ(4,*,END=99998)THMIN,STEP,THMAX
         NPTS = (THMAX-THMIN)/STEP+1.5
         NLINES = NPTS/10+1
         J = 0
         DO 22 I=1,NLINES
           READ(4,23,END=99998)(Y(J+NO),NO=1,10)
           READ(4,24,END=99998)(VAR(J+NO),NO=1,10)
           J = J+10
   22    CONTINUE
         VAR(1) = VAR(1)**2
         DO 25 I=2,NPTS
            IF (Y(I).EQ.0) Y(I) = Y(I-1)
            IF (VAR(I).LE.0.00001) VAR(I) = 1.0
            VAR(I) = VAR(I)**2
   25    CONTINUE         
         IF (JCIL.EQ.1) WRITE(2,7)NUMOR,INUM,TS
      ELSE IF (INSTR.EQ.5) THEN
*
* READ DATA FROM SYNCHROTRON SOURCE AND CORRECT DATA FOR DEAD TIME
*
         READ(4,26,END=99998)DATE1,DATAID
         WRITE(6,27)DATAID
         READ(4,28,END=99998)NRANGE,CHMBRI,TAUK
         NPTS = 0
         DO 29 J=1,NRANGE
           READ(4,30,END=99998)ANGMIN,STEP,ANGMAX,STPTMIN,OFSTI0,OFSTI1
           IPTS = (ANGMAX-ANGMIN)/STEP+1.5
           IF (J.EQ.1) THMIN = ANGMIN
           IF (J.EQ.NRANGE) THMAX = ANGMAX
           IF (J.GT.1) THEN
              READ(4,31,END=99998)
              IPTS = IPTS-1
           END IF
           IF (NPTS+IPTS.GT.IDSZ) THEN
              WRITE(6,32)IDSZ,NPTS+IPTS
              WRITE(7,32)IDSZ,NPTS+IPTS
              STOP 'TOO MANY DATA POINTS'
           END IF
           IF (DATE1.EQ.'OCT85') THEN
              READ(4,31,END=99998)(Y(I+NPTS),VAR(I+NPTS),I=1,IPTS)
           ELSE IF (DATE1.EQ.'FEB86') THEN
              READ(4,33,END=99998)(Y(I+NPTS),VAR(I+NPTS),I=1,IPTS)
           ELSE IF (DATE1.EQ.'AUG86') THEN
              READ(4,34,END=99998)(VAR(I+NPTS),Y(I+NPTS),I=1,IPTS)
           ELSE
              WRITE(6,35)
           END IF
           TAUK = 2.4621E-6
           DO 36 I=NPTS+1,NPTS+IPTS
             Y(I) = Y(I)/STPTIM
             FLEET1 = VAR(I)-OFSTIO
             FLEET2 = FLEET1/CHMBRI
             FLEET2 = (FLEET2*STPTIM*(1-TAUK*Y(I)))**2
             VAR(I) = (STPIM*Y(I))/FLEET2
             Y(I) = (Y(I)/(1-TAUK*Y(I))-OFSTI1)*CHMBRI/FLEET1
             IF (ABS(Y(I)).LT.0.01) Y(I) = 1
   36      CONTINUE
           NPTS = NPTS+IPTS
   29    CONTINUE
      ELSE IF (INSTR.EQ.6) THEN
*
* DATA FROM D1A,D2B  (FILES *.SUM, RENAMED *.DAT, AS PREPARED BY D1ASUM 
*                     OR D2BSUM PROGRAMS)
*
        READ(4,'(A72)') P1A
        READ(4,'(2I8,F8.3,3I)')I1,I2,STEP,I3,I4,I5
	READ(4,'(F8.3)')THMIN
	READ(4,'(F8.0)') RMONI
         J = 0
         NPUNT = NINT(18./STEP)
         DO I=1,NPUNT
           READ(4,3)(IWW(J+NO),Y(J+NO),NO=1,10)
        IF(Y(J+1).EQ.-1000.) GOTO 999
           J = J+10
	 END DO
999	J=J-10
	NPTS=J 
         THMAX = THMIN+(NPTS-1)*STEP
         DO  I=1,NPTS
           IF (Y(I).LE.0.00001) Y(I) = 1.0
           IF (IWW(I).EQ.0) IWW(I) = 1
           VAR(I) = Y(I)/FLOAT(IWW(I))
         END DO
         IF (JCIL.EQ.1) WRITE(2,7)NUMOR,INUM,TS
      ELSE IF (INSTR.EQ.7) THEN
*
* DATA FROM D4,D20L
*                  
	READ(4,'(I5,1X,F5.0,1X,A72)')NPTS,TSAMP,P1A
	READ(4,'(5(F7.2,1X,F8.1,1X,F5.1))')(BK(I),Y(I),VAR(I),I=1,NPTS)
        STEP=BK(2)-BK(1)
	THMIN=BK(1)
        THMAX=BK(NPTS)
	DO I=1,NPTS
         VAR(I)=VAR(I)*VAR(I)
         BK(I)=0.0
	END DO
        IF (JCIL.EQ.1) WRITE(2,7)NUMOR,INUM,TSAMP
      ELSE
         STOP 'PARAMETER INSTR TOO HIGH'
      END IF
*
*
    1 FORMAT(/1X,'READING INTENSITY DATA'/)
    2 FORMAT(1X,'PROGRAM CAN HANDLE',I5,'POINTS',/,
     *       1X,I5,'DATA WERE INPUT')
    3 FORMAT(10(I2,F6.0))
    5 FORMAT(20A4)
    6 FORMAT(/1X,'DATE OF EXPERIMENT:',20A4)
    7 FORMAT(I8,I4,F12.2)
    8 FORMAT(F7.3,10F6.0)
   10 FORMAT(1X,'NUMOR=',I7,1X,'TITLE OF EXPERIMENT:',20A4)
   11 FORMAT(I5)
   12 FORMAT(1X,A,2X,A,2X,A)
   13 FORMAT(I3,1X,I6,1X,I4)
   14 FORMAT(F13.0,F9.0,1X,10(F8.3,1X))
   15 FORMAT(I4,1X,5(F9.3,1X),29X,I6,3X,I6)
   16 FORMAT(1X,'NUMOR: ',I6,' NSUM: ',I4,' TEMP.SAMP. ',F12.3)
   17 FORMAT(' NUMBER OF DATA LINES: ',I5/)
   19 FORMAT(10(I2,F8.0))
   20 FORMAT(I10)
   23 FORMAT(10F8.0)
   24 FORMAT(10F8.1)
   26 FORMAT(A5,A56)
   27 FORMAT(A56)
   28 FORMAT(BZ,I8,F8.0,G10.0)
   30 FORMAT(BZ,6F8.0)
   31 FORMAT(BZ,24X,F7.0,1X,F7.0)
   32 FORMAT(1X,'PROGRAM CAN HANDLE ',I5,'POINTS',/,
     *       1X,I5,' POINTS WERE INPUT',/,
     *       ' INCREASE IDSZ IN PARAMETER STATEMENT')
   33 FORMAT(BZ,24X,F7.0,1X,F7.0)
   34 FORMAT(BZ,51X,F10.0,1X,F10.0)
   35 FORMAT(5X,'WHEN WAS THIS DATA TAKEN. OCT85,FEB86 OR AUG86')
   37 FORMAT(I8,I4,F12.2,7(F8.3),5(F8.4))
      RETURN
99998 STOP 'END OF FILE TAPE 4' 
      END
C
C
C
      SUBROUTINE REFLEC(IPHASE,ZERO,DISP,TRANSP,PREF,PREFOR)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/HKLCTL/KZ(3,24),AZ(24),NCN(70),ICQ,N1,IER,HN
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/REFLS/IREFS(IRS),REFS(IRS,3),MLT(IRS),PHASEN(IRS),ICX(8)
     } ,HALFL(IRS),HALFG(IRS),GAM(IRS)
      REAL LAMDA
      INTEGER H1,H2,H3
      LOGICAL ORH1,ORH2,ORH3
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/SPG/NSPGRP,K,M(10),FILL(3)
      COMMON/CELLX/A,B,C,ALPHA,BETA,GAMMA,AL(3,3)
      DIMENSION PREF(8,3)
      EQUIVALENCE (AL(1,1),ASTAR),(AL(2,2),BSTAR),(AL(3,3),CSTAR),
     *(AL(1,2),BACOSC),(AL(1,3),CACOSB),(AL(2,3),BCCOSA)
      CHARACTER*8 LAU(14),NAMEFIL
      CHARACTER PHA(8)*1
      DATA LAU(1),LAU(2),LAU(3),LAU(4),LAU(5),LAU(6),LAU(7),LAU(8),
     *LAU(9),LAU(10),LAU(11),LAU(12),LAU(13),LAU(14)
     */'1BAR','2/M','MMM','4/M','4/MMM','3BAR   R','3BAR M R','3BAR',
     *'3BAR M 1','3BAR 1 M','6/M','6/MMM','M3','M3M'/
      DATA PHA/'1','2','3','4','5','6','7','8'/
      SIN1(A)=SIN(A*6.28318531)
      RAD=3.14159265359/360.0
      IF ( K.GT.3 ) STOP 5001
      KXIS=K
C
C
C
 97   TMIN = (SIN1(THMIN/720.0)/LAMDA(1))**2
      IC = 0
      IF (IPHASE.GE.2) THEN
         DO 4100 IIPHAS=2,IPHASE
4100     IC = IC+ICX(IIPHAS-1)
      END IF
      SMAX = (SIN1(THMAX/720.0)/LAMDA(1))**2
      IF(LAMDA(2).GT.LAMDA(1))TMIN=TMIN*(LAMDA(1)/LAMDA(2))**2
      IF(LAMDA(2).GT.0..AND.LAMDA(2).LT.LAMDA(1))SMAX=SMAX*
     *(LAMDA(1)/LAMDA(2))**2
      CALL OP1
      WRITE(6,36)LAU(NSPGRP)
   36 FORMAT(15H LAUE SYMMETRY ,A8,' INDICES ARE READ FROM FILE ')
C
C   OPENING FILES TO READ HKL'S
C
      NAMEFIL='HKL'//PHA(IPHASE)//'.HKL'
      OPEN(UNIT=21,FILE=NAMEFIL,STATUS='OLD')
C
C   READING H K L AND MULTIPLICITY
C
 8000 READ(21,*,END=2303) H1,H2,H3,MM
C
      SQ=FLOAT(H1*H1)*ASTAR+FLOAT(H2*H2)*BSTAR+FLOAT(H3*H3)*CSTAR
     1+FLOAT(H1*H2)*BACOSC+FLOAT(H1*H3)*CACOSB+FLOAT(H2*H3)*BCCOSA
      SQ=SQ/4.
      IF ( SQ-SMAX ) 3000,3000,8000
 2303 ICX(IPHASE)=IC
      IF (IPHASE.GE.2) THEN
         DO 4101 IIPHAS=2,IPHASE
4101     ICX(IPHASE) = ICX(IPHASE)-ICX(IIPHAS-1)
      END IF
      CALL SORT(IPHASE)
      RETURN
 3000 IF ( SQ - TMIN ) 8000,3117,3117
 3117 IF ( IC.GT.IRS-2 ) GO TO 6001
C     NEXT IF BLOCK FOR PHASE WITH DISTINCT ORIENTATION ALONG PREF(K,I)
      IF (PREFOR.GT.99.) THEN
C
        ORH1 = IFIX(PREF(IPHASE,1)).EQ.H1
        IF (.NOT.(ORH1).AND.H1.NE.0.AND.IFIX(PREF(IPHASE,1)).NE.0)
     *     ORH1 = MOD(H1,IFIX(PREF(IPHASE,1))).EQ.0
        IF (.NOT.ORH1) GO TO 8000
C
        ORH2 = IFIX(PREF(IPHASE,2)).EQ.H2
        IF (.NOT.(ORH2).AND.H2.NE.0.AND.IFIX(PREF(IPHASE,2)).NE.0)
     *     ORH2 = MOD(H2,IFIX(PREF(IPHASE,2))).EQ.0
        IF (.NOT.ORH2) GO TO 8000
C
        ORH3 = IFIX(PREF(IPHASE,3)).EQ.H3
        IF (.NOT.(ORH3).AND.H3.NE.0.AND.IFIX(PREF(IPHASE,3)).NE.0)
     *     ORH3 = MOD(H3,IFIX(PREF(IPHASE,3))).EQ.0
        IF (.NOT.ORH3) GO TO 8000
        IORDR1=0
        IORDR2=0
        IORDR3=0
        IF (H1.NE.0) IORDR1 = INT(H1/IFIX(PREF(IPHASE,1)))
        IF (H2.NE.0) IORDR2 = INT(H2/IFIX(PREF(IPHASE,2)))
        IF (H3.NE.0) IORDR3 = INT(H3/IFIX(PREF(IPHASE,3)))
        IF (IORDR1.EQ.IORDR2.AND.IORDR2.EQ.IORDR3) GO TO 9257
        IF (IORDR1.EQ.0.AND.(IORDR2.EQ.IORDR3)) GO TO 9257
        IF (IORDR2.EQ.0.AND.(IORDR3.EQ.IORDR1)) GO TO 9257
        IF (IORDR3.EQ.0.AND.(IORDR1.EQ.IORDR2)) GO TO 9257
        IF (IORDR1.EQ.0.AND.IORDR2.EQ.0) GO TO 9257
        IF (IORDR2.EQ.0.AND.IORDR3.EQ.0) GO TO 9257
        IF (IORDR3.EQ.0.AND.IORDR1.EQ.0) GO TO 9257
      END IF
9257  CONTINUE
C     SEPARATE PHASE FOR ORIENTATION COMPLETE
      KZ(1,1)=H1
      KZ(2,1)=H2
      KZ(3,1)=H3
      AZ(1)=0.0
      IER=0
      CALL SMTRY2
      IF(IER.NE.0)GOTO 8000
      LXN=2
      IF(LAMDA(2).EQ.0..OR.LAMDA(2).EQ.LAMDA(1))LXN=1
      DO 3118 LX1=1,LXN
      SQH=SQ*LAMDA(LX1)*LAMDA(LX1)
      TAN2=SQH/(1.-SQH)
      IF(SQH.GE.1.)GOTO 3118
      TANX=SQRT(TAN2)
C     SHIFT DUE TO SAMPLE DISPLACEMENT AND TRANSPARENCY
      SHIFT =  DISP*SQRT(1-SQH)+TRANSP*SQRT(1.-(1.-2.*SQH)*(1.-2.*SQH))
      POS=ATAN(TANX)/RAD+ ZERO + SHIFT
      IF(POS.GT.THMAX.OR.POS.LT.THMIN)GOTO 3118
      IC=IC+1
C
C ABSORPTION CORRECTION FOR NEUTRON CASE
C 
      XABS=1.0
      IF(TMV.GT.0.000001.AND.JOBTYP.EQ.2) THEN
        XABS = EXP(-(1.7133-0.0368*SQH)*TMV+(0.0927+0.375*SQH)*TMV*TMV)
      END IF
      PLOR=1./(2.*SQH*SQRT(1.-SQH))*XABS
       IF (INSTR.EQ.4.OR.INSTR.EQ.5) THEN
       PLOR = PLOR * (1-RKK+RKK*(1.-2.*SQH)*(1.-2.*SQH))
       GO TO 4000
       END IF
      IF(JOBTYP.EQ.3)PLOR=PLOR*(1.+(1.-2.*SQH)*(1.-2.*SQH)*CTHM)
      IF(JOBTYP.EQ.1)PLOR=PLOR*(1.+(1.-2.*SQH)*(1.-2.*SQH)*CTHM)
4000   CONTINUE
      IREFS(IC)=256*(256*(256*(8*IPHASE+LX1)+128+H1)+128+H2)+128+H3
      MLT(IC)=MM
C
C------CALCULATE HALFWIDTH FOR PSEUDOVOIGT WITH GAUSS AND LORENTZ
      IF (NPROF.EQ.8) THEN
       HALFG(IC) =    (U*TAN2+V*TANX+W)
      IF (HALFG(IC).GT.0.) THEN
          HALFG(IC) = SQRT(HALFG(IC))
       ELSE
          WRITE (6,3456) POS,IPHASE
          WRITE (7,3456) POS,IPHASE
          STOP 'SQUARE OF FWHM IS NEGATIVE'
3456      FORMAT (3X,'SQUARE OF FWHM NEGATIVE AT TWO-THETA',F8.3,
     }    'FOR PHASE NO. ',I4)
      END IF
       HALFL(IC) = ULOR*TANX+VLOR/SQRT(1.-SQH)
       REFS(IC,1) = (HALFG(IC)**5.+2.69269*HALFG(IC)**4.*HALFL(IC)+
     1 2.42843*HALFG(IC)**3.*HALFL(IC)**2.+
     2 4.47163*HALFG(IC)**2.*HALFL(IC)**3. +
     3 0.07842*HALFG(IC)*HALFL(IC)**4. + HALFL(IC)**5.)**0.2
       TLR = HALFL(IC)/REFS(IC,1)
       GAM(IC) = 1.36603*TLR-0.47719*TLR*TLR+0.11116*TLR**3.
       GO TO 7000
      END IF
      REFS(IC,1)=    (U*TAN2+V*TANX+W)
      IF (REFS(IC,1 ).GT.0.) THEN
          REFS(IC,1)= SQRT(REFS(IC,1))
       ELSE
          WRITE (6,3456) POS,IPHASE
          WRITE (7,3456) POS,IPHASE
          STOP 'SQUARE OF FWHM IS NEGATIVE'
      END IF
7000  REFS(IC,2)=POS
      REFS(IC,3)=PLOR
 3118 CONTINUE
      GOTO 8000
 6001 WRITE(6,24) IRS
      WRITE(7,24) IRS
   24 FORMAT (1X,I4,'TOO MANY REFLECTIONS, INCREASE *IRS* IN THE'
     },'PARAMETER STATEMENT IN THE SOURCE CODE ')
      STOP
      END
